		.title	mph3 - mph_cg_disp.s

	.comment title

	MPH3 zGRAM  GRAM ][`

					written by Herzen

title


* Include File -------------------------------- *

		.include	mph.h
		.include	mph_lib.h
		.include	config.h

		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xdef	to_gram
		.xdef	to_gram_sabun
		.xdef	tonedown
		.xdef	tonedown50
		.xdef	tonedown_nowait
		.xdef	trans_clr
		.xdef	trans_clrx
		.xdef	text_on
		.xdef	text_off
		.xdef	GCLR
		.xdef	gram_to_buff
		.xdef	gram_to_buff_only
		.xdef	gram_to_buff256
		.xdef	gram_to_buff256_only


* Fixed Number -------------------------------- *

*SCREEN_MODE:	.equ	3
*CRTMODWORK:	.equ	$093C

T_ON:		.equ	$20
G_ON:		.equ	$1f


* IOCS Work ----------------------------------- *

MPY_TYPE:	.equ	$cbc


* I/O Address --------------------------------- *

GVRAM:		.equ	$c00000
GVRAM_END:	.equ	$e00000

CRTC:		.equ	$e80000
~CRTC_R12:	.equ	$18
~CRTC_R13:	.equ	$1a
~CRTC_R14:	.equ	$1c
~CRTC_R15:	.equ	$1e
~CRTC_R20h:	.equ	$28
~CRTC_R20l:	.equ	$29
~CRTC_R21l:	.equ	$2b
~CRTC_ACT:	.equ	$481

GRA_PALET:	.equ	$e82000
TEXT_PALET:	.equ	$e82200
VC_R0:		.equ	$e82400
VC_R2:		.equ	$e82600


* Macro --------------------------------------- *

DOT16_INIT:	.macro
		moveq	#0,d4
		.endm

DOT16:		.macro
		.rept 16
		move.b	(a2)+,d4
		move	d4,(a3)+
		.endm
		.endm


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

to_gram::
		move	(_gram_disp_mode,a5),d0
		beq	to_gram_end
		cmpi	#8,(_color,a5)
		beq	to_gram256

		tst	(_count_pic,a5)
		bne	@f
		bsr	SCREEN
@@:
*		subq	#1,d0
		add	d0,d0
		move	(to_gram_table-2,pc,d0.w),d0
		jmp	(to_gram_table,pc,d0.w)
to_gram_table:
		.dc	mode1-to_gram_table	;1
		.dc	mode2-to_gram_table	;2
		.dc	mode3-to_gram_table	;-wf,-ap
		.dc	mode4-to_gram_table	;-t1p(exp mode)
		.dc	mode5-to_gram_table	;E\

to_gram256:
		bsr	SCREEN256
		clr	(_count_pic,a5)
*		subq	#1,d0
		add	d0,d0
		move	(to_gram_table256-2,pc,d0.w),d0
		jmp	(to_gram_table256,pc,d0.w)
to_gram_table256:
		.dc	mode1_256-to_gram_table256	;1
		.dc	mode1_256-to_gram_table256	;2(b)
		.dc	mode3_256-to_gram_table256	;-wf,-ap
		.dc	mode3_256-to_gram_table256	;-t1p(exp mode)(b)
		.dc	mode5_256-to_gram_table256	;E\

to_gram_end:
		rts


*-------------------------------------------------------------------------------
*
* 256F^CvRiʂɕ\g[_E@F1024x1024j

mode3_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		moveq	#0,d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#512-1,(_ymax,a5)
		move	#512,(_xmax,a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvPiʏ\g[_E@F768x512j

mode1_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		tst	(_gram_disp_wait,a5)
		bne	@f
		bsr	palet_tonedown_set
@@:
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#512-1,(_ymax,a5)
		move	#512,(_xmax,a5)
		bsr	to_gram_main

		tst	_gram_disp_wait(a5)
		beq	@f
		bsr	tonedown
@@:
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ^CvPiʏ\g[_E@F768x512j

mode5_256:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	GCLR
		bsr	scrnset256

		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set

		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_line,a5),d0
		move	#512-16,d1
		sub	d0,d1
		bge	@f
		moveq	#0,d1
@@:
		move	(_colum,a5),d0
		move	#768-16,d2
		sub	d0,d2
		bge	@f
		moveq	#0,d2
@@:
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#1024,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#512-1,(_ymax,a5)
		move	#512,(_xmax,a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts



*-------------------------------------------------------------------------------
*
* 16F^CvSig[_EȂF1024x1024j

mode4:
		movem.l	d0-d7/a0-a6,-(sp)
		addq	#1,(_count_pic,a5)
		bsr	to_super
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#1024-1,(_ymax,a5)
		move	#1024,(_xmax,a5)
		bsr	to_gram_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* 16F^CvRiʂɕ\g[_E@F1024x1024j

mode3:
		movem.l	d0-d7/a0-a6,-(sp)
		addq	#1,(_count_pic,a5)
		bsr	to_super
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#1024-1,(_ymax,a5)
		move	#1024,(_xmax,a5)
		bsr	to_gram_main

**		bsr	tonedown
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvPiʏ\g[_E@F768x512j

mode1:
		movem.l	d0-d7/a0-a6,-(sp)
		addq	#1,(_count_pic,a5)
		bsr	to_super
		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		tst	(_gram_disp_wait,a5)
		bne	@f
		bsr	palet_tonedown_set
@@:
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#512-1,(_ymax,a5)
		move	#768,(_xmax,a5)
		bsr	to_gram_main

		tst	(_gram_disp_wait,a5)
		beq	@f
		bsr	tonedown
@@:
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

* ^CvQi摜uԝz֕\@F768x512j

mode2:
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super
		tst	(_count_pic,a5)
		bne	@f

		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
@@:
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

		lea	(GVRAM),a0
		addq	#1,(_count_pic,a5)
		btst	#0,(_count_pic+1,a5)
		beq	@f
		lea	(GVRAM+2048*512),a0
@@:
		bsr	gclr_a
		move	#512-1,(_ymax,a5)
		move	#768,(_xmax,a5)
		bsr	to_gram_main

		move	#T_ON,(VC_R2)
*		bsr	palet_set
*		bsr	tonedown_2
		bsr	palet_tonedown_set

		moveq	#0,d0
		btst	d0,(_count_pic+1,a5)
		beq	@f
		move	#512,d0
@@:
		lea	(CRTC),a0
		move.l	d0,(~CRTC_R12,a0)	;(0,0) or
		move.l	d0,(~CRTC_R14,a0)	;(0,512)
		moveq	#%100,d0
		move.b	d0,(~CRTC_R20h,a0)
		move	d0,(VC_R0-CRTC,a0)

		moveq	#T_ON+G_ON,d0
		tst.b	(_text_mask_flag,a5)
		beq	@f
		moveq	#G_ON,d0
@@:		move	d0,(VC_R2-CRTC,a0)

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts


* ^CvTiE\g[_E@F768x512j

mode5:
		movem.l	d0-d7/a0-a6,-(sp)
		addq	#1,(_count_pic,a5)
		bsr	to_super

		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
		bsr	palet_set
		moveq	#0,d2
		tst	(_200flag,a5)
		sne	d2

*		lea	(GVRAM),a0
		movem.l	d0-d2,-(sp)
		move	(_line,a5),d0
		move	#512-16,d1
		sub	d0,d1
		bge	@f
		moveq	#0,d1
@@:
		move	(_colum,a5),d0
		move	#768-16,d2
		sub	d0,d2
		bge	@f
		moveq	#0,d2
@@:
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

		move	#512-1,(_ymax,a5)
		move	#768,(_xmax,a5)
		bsr	to_gram_main

**		bsr	tonedown
		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts



*-------------------------------------------------------------------------------

gclr_a:
	movem.l	d1-d7/a0-a5,-(sp)
	moveq	#0,d1
	move.l	d1,d2
	move.l	d1,d3
	move.l	d1,d4
	move.l	d1,d5
	move.l	d1,d6
	move.l	d1,d7
	movea.l	d1,a1
	movea.l	d1,a2
	movea.l	d1,a3
	movea.l	d1,a4
	movea.l	d1,a5
	move.w	#512-1,d0
	adda.l	#$100000,a0
@@:
	lea	(-(2048-768*2),a0),a0
	.rept 32
	movem.l	d1-d7/a1-a5,-(a0)
	.endm
	dbra	d0,@b
	movem.l	(sp)+,d1-d7/a0-a5
	rts


* in	d2.b	$00=ʏ $ff=c{g(200lineflag)
*		(bit8ȏ0ɂ)

to_gram_main:
		movea.l	(_buff_addr,a5),a1
		move	(_line,a5),d0
		subq	#1,d0
		cmp	(_ymax,a5),d0
		bls	XY_lop
		move	(_ymax,a5),d0
XY_lop:						* I[gXN[Ȃ
		bsr	trans_line
		tst	d2
		beq	xy_cont			;_200flag off
		swap	d2
		tst	d2
		bne	@f
		not.b	d2			;ʃ[h=$00:㑤̃C
		swap	d2
		bra	XY_lop
@@:		not.b	d2			;ʃ[h=$ff:̃C
		swap	d2
xy_cont:
		adda	(_colum,a5),a1
		dbra	d0,XY_lop
		rts

*-------------------------------------------------------------------------------
*
* pbg֌W
*

* PAL  TPALET
palet_set:
		lea	(_pal_buf,a5),a0
		lea	(GRA_PALET),a1
		moveq	#1,d0
		move	(_color,a5),d1
		lsl.l	d1,d0
		subq	#1,d0
@@:		move	(a0)+,(a1)+
		dbra	d0,@b
		rts

* PAL  tonedown  TPALET
palet_tonedown_set:
		lea	(-768,sp),sp
		lea	(sp),a0
		lea	(_pal_buf,a5),a1
		bsr	pal_to_rgb

		move	(_gram_disp_palet,a5),d5
		lea	(sp),a0
		bsr	set_pal
		lea	(768,sp),sp
		rts


* TPALET  tonedown  TPALET
tonedown::
		lea	(-768,sp),sp
		lea	(sp),a0
		lea	(GRA_PALET),a1
		bsr	pal_to_rgb

		moveq	#0,d1
		move	(_gram_disp_wait,a5),d1
		bsr	time_wait

		cmpi	#100,(_gram_disp_palet,a5)
		beq	tonedown_end

		moveq	#4,d1
		lea	(sp),a0
		moveq	#95,d5
@@:		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		cmp	(_gram_disp_palet,a5),d5
		bhi	@b
tonedown_end:
		lea	(768,sp),sp
		rts

	.if	0

* TPALET  fadeout  TPALET
palet_fadeout:
		lea	(-48,sp),sp
		lea	(sp),a0
		lea	(_pal_buf,a5),a1
		bsr	pal_to_rgb

		tst	(_gram_disp_palet,a5)
		beq	fadeout_end

		lea	(sp),a0
		moveq	#12,d1
		move	(_gram_disp_palet,a5),d5
@@:
		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		bpl	@b
fadeout_end:
		lea	(48,sp),sp
		rts

* TPALET  fadein  TPALET
palet_fadein:
		lea	(-48,sp),sp
		lea	(sp),a0
		lea	(_pal_buf,a5),a1
		bsr	pal_to_rgb

		lea	(sp),a0
		moveq	#12,d1
		moveq	#0,d5
@@:
		bsr	set_pal
		bsr	time_wait
		addq	#5,d5
		cmp	(_gram_disp_palet,a5),d5
		bcs	@b

		lea	(48,sp),sp
		rts

	.endif

pal_to_rgb:
		moveq	#1,d0
		move	(_color,a5),d1
		lsl	d1,d0
		subq	#1,d0
pal_to_rgb_loop:
		move	(a1)+,d1

		move	#%11111<<(5+1),d2
		and	d1,d2
		btst	#0,d1
		beq	@f
		ori	#1<<5,d2		;if(I==1) R+=0.5;
@@:		lsr	#3,d2
		move.b	d2,(a0)+

		move	#%11111<<(5+5+1),d2
		and	d1,d2
		btst	#0,d1
		beq	@f
		ori	#1<<(5+5),d2		;if(I==1) G+=0.5;
@@:		move	d2,-(sp)
		move.b	(sp)+,(a0)+

		andi	#%11111_1,d1
		add.b	d1,d1
		add.b	d1,d1
		move.b	d1,(a0)+

		dbra	d0,pal_to_rgb_loop
		rts


* TPALET  tonedown  TPALET
* OĂяop
tonedown_nowait::
		cmpi	#100,(_gram_disp_palet,a5)
		beq	tonedown_nw_end

		bsr	to_super
		lea	(-768,sp),sp
		lea	(sp),a0
		lea	(GRA_PALET),a1
		moveq	#1,d0
		move	(_color,a5),d1
		lsl.l	d1,d0
		subq	#1,d0
tonedown_nowait_loop:
		move	(a1)+,d1
		move	d1,d2
		andi	#%11111<<(5+1),d2
		btst	#0,d1
		beq	@f
		ori	#1<<5,d2		;if(I==1) R+=0.5;
@@:		lsr	#3,d2
		move.b	d2,(a0)+

		move	d1,d2
		andi	#%11111<<(5+5+1),d2
		btst	#0,d1
		beq	@f
		ori	#1<<(5+5),d2		;if(I==1) G+=0.5;
@@:		move	d2,-(sp)
		move.b	(sp)+,(a0)+

		andi	#%11111_1,d1
		add.b	d1,d1
		add.b	d1,d1
		move.b	d1,(a0)+

		dbra	d0,tonedown_nowait_loop

		moveq	#0,d1
		lea	(sp),a0
		moveq	#4,d1
		moveq	#95,d5
@@:		bsr	set_pal
		bsr	time_wait
		subq.l	#5,d5
		cmp	(_gram_disp_palet,a5),d5
		bhi	@b

		lea	(768,sp),sp
		bsr	to_user
tonedown_nw_end:
		rts


* RGB  TPALET
set_pal:
		movem.l	d0-d4/a0-a1,-(sp)
		lea	(GRA_PALET),a1
		moveq	#1,d4
		move	(_color,a5),d1
		lsl.l	d1,d4
		subq	#1,d4
set_pal_lop
		moveq	#0,d1
		move.b	(a0)+,d1
		mulu	d5,d1
		divu	#100,d1
		moveq	#0,d0
		move.b	(a0)+,d0
		mulu	d5,d0
		divu	#100,d0
		moveq	#0,d2
		move.b	(a0)+,d2
		mulu	d5,d2
		divu	#100,d2
		lsl	#8,d0
		andi	#%11111<<(5+5+1),d0
		lsl	#3,d1
		andi	#%11111<<(5+1),d1
		lsr	#2,d2
		andi	#%11111_1,d2
		or	d1,d0
		or	d2,d0
		move	d0,(a1)+
		dbra	d4,set_pal_lop
		movem.l	(sp)+,d0-d4/a0-a1
		rts

tonedown50::
		movem.l	d0-d1/a0,-(sp)
		moveq	#16-1,d0
		cmpi	#8,(_color,a5)
		bne	@f
		move	#256-1,d0
@@:
		lea	(GRA_PALET),a0
@@:		move	(a0),d1
		lsr	#1,d1
		andi	#%0111101111011110,d1
		move	d1,(a0)+
		dbra	d0,@b
		movem.l	(sp)+,d0-d1/a0
		rts

*-------------------------------------------------------------------------------

scrnset:
		lea	(CRTC),a0
		clr.l	(~CRTC_R12,a0)
		clr.l	(~CRTC_R14,a0)
scrnset2:
		lea	(CRTC),a0
		moveq	#%100,d0		;1024x1024,16F
		move.b	d0,(~CRTC_R20h,a0)
		move	d0,(VC_R0-CRTC,a0)
scrnset_tgon:
		moveq	#T_ON+G_ON,d0
		tst.b	(_text_mask_flag,a5)
		beq	@f
		moveq	#G_ON,d0
@@:		move	d0,(VC_R2-CRTC,a0)
		rts

scrnset256:
		lea	(CRTC),a0
		clr.l	(~CRTC_R12,a0)
		clr.l	(~CRTC_R14,a0)
scrnset256_2:
		lea	(CRTC),a0
		moveq	#%001,d0		;512x512,256F
		move.b	d0,(~CRTC_R20h,a0)
		move	d0,(VC_R0-CRTC,a0)
		bra	scrnset_tgon


* trans_line routine
*	programmed by AKIRA.Y
*	  modified by Herzen

trans_line:
		move.l	a0,a3			* a0 , a3 = CURRENT GRAM LINE
		lea	(1024,a0),a0		* a0 = NEXT GRAM LINE
		cmpi	#8,(_color,a5)
		beq	@f
		lea	(1024,a0),a0
@@:		move.l	a1,a2
		moveq	#0,d5
		move	(_colum,a5),d3
		cmp	(_xmax,a5),d3
		bls	@f
		move	(_xmax,a5),d3
@@:		move.l	a2,d4
		andi	#1,d4
		bne	trans_line_eq02
		lsr	#4,d3
		beq	trans_line_eq0
		subq.l	#1,d3

		DOT16_INIT			;[vy:-)
trans_line_eql:
		DOT16
		dbra	d3,trans_line_eql
trans_line_eq0:
		moveq	#0,d5
		move	(_colum,a5),d3
		cmp	(_xmax,a5),d3
		bls	@f
		move	(_xmax,a5),d3
@@:		andi	#15,d3
		beq	trans_line_eqe
trans_line_eq02:
		subq.l	#1,d3
trans_line_eq0l:
		move.b	(a2)+,d5
		move	d5,(a3)+
		dbra	d3,trans_line_eq0l
trans_line_eqe:
		rts

*-------------------------------------------------------------------------------
trans_clrx::
		tst.b	(_no68_flag,a5)		* 68p̈ɃANZXȂH
		bne	trans_clr_end

		move	(_gram_disp_mode,a5),d0		* GRAM_DISP type2 ͋NA
		subq	#2,d0
		beq	trans_clr
		tst.b	(_gclr_off_flag,a5)
		bne	trans_clr_texton
trans_clr::
		move	(_gram_disp_mode,a5),d0
		and	(_count_pic,a5),d0
		beq	trans_clr_end

		movem.l	d0-d7/a0-a6,-(sp)
		bsr	to_super

		bsr	scrnset
		bsr	GCLR
		bsr	scrnset2

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
trans_clr_texton:
		bsr	to_super
		move	#T_ON+G_ON,(VC_R2)
		bsr	to_user
trans_clr_end:
		rts

*-------------------------------------------------------------------------------
* Hispeed GRAM CLEAR
*	programmed by H.ATA
*

GCLR::
		movem.l	d0/a0-a1,-(sp)
		lea	(CRTC),a1
		moveq	#%100,d0
		move.b	d0,(~CRTC_R20h,a1)
		move	d0,(VC_R0-CRTC,a1)
		move.b	(~CRTC_R21l,a1),-(sp)
		move.b	#$0f,(~CRTC_R21l,a1)

		moveq	#1,d0			;OtBbNNA̐rbg
		lea	(~CRTC_ACT,a1),a0

		clr.l	(~CRTC_R12,a1)		;㔼
		bset	d0,(a0)
@@:		btst	d0,(a0)
		beq	@b			;Jn܂őҋ@
@@:		btst	d0,(a0)
		bne	@b			;I܂őҋ@

		move	#512,(~CRTC_R13,a1)	;
		bset	d0,(a0)
@@:		btst.b	d0,(a0)
		beq	@b
@@:		btst	d0,(a0)
		bne	@b

		clr.l	(~CRTC_R12,a1)
		move.b	(sp)+,(~CRTC_R21l,a1)
		movem.l	(sp)+,d0/a0-a1
		rts

*-------------------------------------------------------------------------------

time_wait:
		movem.l	d1-d3,-(sp)
		move.l	d1,d2
		beq	time_wait_end
		IOCS	_ONTIME
		move.l	d0,d3
ti_lop:
		IOCS	_ONTIME
		cmp.l	d3,d0
		bcc	@f
		subi.l	#24*60*60*100,d3
@@:		sub.l	d3,d0
		cmp.l	d2,d0
		bcs	ti_lop
time_wait_end:
		movem.l	(sp)+,d1-d3
		rts

*-------------------------------------------------------------------------------

text_off::
	tst.b	(_text_mask_flag,a5)
	beq	@f
	bsr	to_super
	andi	#.not.T_ON,(VC_R2)
	bsr	to_user
@@:	rts

text_on::
	tst.b	_text_mask_flag(a5)
	beq	@f
	bsr	to_super
	ori	#T_ON,(VC_R2)
	bsr	to_user
@@:	rts

*-------------------------------------------------------------------------------
* GRAM to zGRAM Rs[

gram_to_buff::
		bsr	to_super

		lea	(GRA_PALET),a1
		lea	(_pal_buf,a5),a0
		moveq	#16/2-1,d0
@@:
		move.l	(a1)+,(a0)+
		dbra	d0,@b
		bra	@f

gram_to_buff_only::
		bsr	to_super
@@:
		lea	(GVRAM),a2
		movea.l	(_buff_addr,a5),a1

		moveq	#0,d0
		moveq	#0,d1
		move	(_scolum,a5),d0
		move	(_sline,a5),d1
		add	d0,d0
		mulu	#2048,d1
		adda.l	d0,a2
		adda.l	d1,a2

		move	(_colum,a5),d3
		subq	#1,d3
		move	(_line,a5),d2
		subq	#1,d2
outlop:
		move	d3,d1
		lea	(a2),a0
inlop:		move	(a0)+,d0
		move.b	d0,(a1)+
		dbra	d1,inlop
		lea	(2048,a2),a2
		dbra	d2,outlop

		bsr	to_user
		rts

gram_to_buff256::
		bsr	to_super

		lea	(GRA_PALET),a1
		lea	(_pal_buf,a5),a0
		moveq	#256/2-1,d0
@@:
		move.l	(a1)+,(a0)+
		dbra	d0,@b
		bra	@f

gram_to_buff256_only::
		bsr	to_super
@@:
		lea	(GVRAM),a2
		movea.l	(_buff_addr,a5),a1

		moveq	#0,d0
		moveq	#0,d1
		move	(_scolum,a5),d0
		move	(_sline,a5),d1
		add	d0,d0
		mulu	#1024,d1
		adda.l	d0,a2
		adda.l	d1,a2

		move	(_colum,a5),d3
		subq	#1,d3
		move	(_line,a5),d2
		subq	#1,d2
outlop_:
		move	d3,d1
		lea	(a2),a0
inlop_:		move	(a0)+,d0
		move.b	d0,(a1)+
		dbra	d1,inlop_
		lea	(1024,a2),a2
		dbra	d2,outlop_

		bsr	to_user
		rts


*----------------------------------------------------------------------------*
* (Ɉ)XN[Zbg :-)

SCREEN:
		movem.l	d0/a0-a1,-(sp)
		bsr	to_super
		clr	(TEXT_PALET)
		lea	(para16,pc),a0
		lea	(CRTC),a1
		moveq	#8-1,d0
@@:		move	(a0)+,(a1)+	* CRTC R0`R7
		dbra	d0,@b

		move	(a0)+,d0	* CRTC R20
		move.b	d0,(CRTC+~CRTC_R20l)

		bsr	to_user
		movem.l	(sp)+,d0/a0-a1
		rts

* p[^QlCMAG.S
* 16FW(31KHz)[h
para16:
		.dc	137,014,028,124,567,005,040,552,$416,095,30	* 31k 768x512
		.even

SCREEN256:
		movem.l	d0-d3/a0-a1,-(sp)
		bsr	to_super

		clr	(TEXT_PALET)

		lea	(para256s,pc),a0
		lea	(CRTC),a1
		moveq	#8-1,d0
@@:		move	(a0)+,(a1)+	* CRTC R0`R7
		dbra	d0,@b

*		move	(a0)+,d0	* CRTC R20
*		move.b	d0,(CRTC+~CRTC_R20l)

		bsr	to_user

		movem.l	(sp)+,d0-d3/a0-a1
		rts

* p[^QlCBIOS ROM (XVI v1.10 '91.01.11)
* 256FXNGA[h
para256s:
	.dc	$0089,$000e,$002c,$006c,$0237,$0005,$0028,$0228,$0315
	.if	0
* 256FW[h
para256:
	.dc	$005B,$0009,$0011,$0051,$0237,$0005,$0028,$0228,$0315
	.endif
	.even

*-
* 摜dˍ
*

to_gram_sabun::
		movem.l	d0-d7/a0-a6,-(sp)
		addq	#1,(_count_pic,a5)
		bsr	to_super
*		bsr	scrnset
*		bsr	GCLR
*		bsr	scrnset2
		move	#T_ON+G_ON,(VC_R2)	* POO
*		bsr	palet_set
		moveq	#0,d2

		movem.l	d0-d2,-(sp)
		move	(_sline,a5),d1
		move	(_scolum,a5),d2
		move.l	#GVRAM,d0		* d2=X, d1=Y
		mulu	#2048,d1
		add.l	d2,d1
		add.l	d2,d1
		add.l	d1,d0
		movea.l	d0,a0
		movem.l	(sp)+,d0-d2

*---* ߂̎Ȑ

		cmpi	#2,(_mixer,a5)
**		cmpi	#MPH_LOAD_MIX_DEF,(_mixer,a5)
		bne	@f

		movea.l	(_buff_addr,a5),a1
		lea	(_mixer+2,a5),a4	* ftHg
		moveq	#0,d0
		move.b	(a1),d0			;(0,0)̐F𓧖Fɂ
		st	(a4,d0.w)
@@:						* ߂̎Ȑ
		moveq	#16-1,d1
		lea	(_mixer+2,a5),a4	* ftHg
		lea	(_mixer_,a5),a1
make_lop:
		tst.b	(a4)+
		bne	@f
		move.l	#$36c4_4e75,(a1)+		* move d4,(a3)+ $36c4
							* rts           $4e75
		dbra	d1,make_lop
		bra	make_end
@@:		move.l	#$544b_4e75,(a1)+		* addq #2,a3    $544b
							* rts           $4e75
		dbra	d1,make_lop
make_end:
		cmpi.b	#1,(MPY_TYPE)
		bls	@f

		moveq	#3,d1
		IOCS	_SYS_STAT
@@:
*---
		bsr	palet_set_mix

		move	#1024-1,(_ymax,a5)
		move	#1024,(_xmax,a5)
		bsr	to_gram_sabun_main

		bsr	to_user
		movem.l	(sp)+,d0-d7/a0-a6
		rts

to_gram_sabun_main:
		lea	(_mixer_,a5),a4		* (0~15)
		movea.l	(_buff_addr,a5),a1
		move	(_line,a5),d0
		subq	#1,d0
		cmp	(_ymax,a5),d0
		bls	XYs_lop
		move	(_ymax,a5),d0
XYs_lop:	bsr	trans_line_sabun
		adda	(_colum,a5),a1
		dbra	d0,XYs_lop
		rts


trans_line_sabun:
		move.l	a0,a3			* a0 , a3 = CURRENT GRAM LINE
		lea	(1024,a0),a0		* a0 = NEXT GRAM LINE
		cmpi	#8,(_color,a5)
		beq	@f
		lea	(1024,a0),a0
@@:		move.l	a1,a2			* a1, a2 zGRAM
		moveq	#0,d5
		move	(_colum,a5),d3
		cmp	(_xmax,a5),d3
		bls	@f
		move	(_xmax,a5),d3
@@:
		moveq	#0,d7
		move.l	d7,d4
		move.l	d7,d5
		lsr	#3,d3
		subq	#1,d3
tls_lop:
		.rept 8
			move.b	(a2)+,d4
			move	d4,d5
			add	d5,d5		* d5 * 4
			add	d5,d5
			jsr	(a4,d5.w)
*			move	d5,(a3)+
		.endm
		dbra	d3,tls_lop
		rts

* d5,d6,d7,a4

palet_set_mix:
		movem.l	d0-d7/a0-a6,-(sp)
		moveq	#16-1,d1
		lea	(_pal_buf,a5),a0
		lea	(GRA_PALET),a1
		lea	(_mixer+2,a5),a4	* ftHg
palet_mix_lop:
		move	(a0)+,d0
		tst.b	(a4)+
		bne	@f
		move	d0,(a1)+
		bra	1f
@@:
		addq	#2,a1
*		or	d0,(a1)+
1:
		dbra	d1,palet_mix_lop
palet_mix_end:
		movem.l	(sp)+,d0-d7/a0-a6
		rts


		.end

* End of File --------------------------------- *
