		.title MPH3G[bZ[W\[` written by Herzen

		.include	iocscall.mac
		.include	doscall.mac

		.xdef	ERROR
		.xdef	IPRINT
		.xdef	DPRINT

		.xref	icrlf


* Fixed Number -------------------------------- *

	.ifdef	__CRLF__
CRLF:		.reg	$0d,$0a
	.else
CRLF:		.equ	$0a
	.endif


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*  G[bZ[W\
*
*  in  : d0.w = ERROR CODE
*        a1.l = t@CAhXi t@ĆCa1NAăR[ j
*

ERROR:
		movem.l	d0-d2/a1,-(sp)
		moveq	#51,d2
		cmp.w	d2,d0
		bhi	@f
		move.w	d0,d2
@@:
		moveq.l	#10,d0
		bsr	IPRINT

		move.w	d2,d0
		bsr	IPRINT

		move.l	a1,d0			* tst.l	a1
		beq	@f
		moveq.l	#'(',d1
		IOCS	_B_PUTC
		IOCS	_B_PRINT
		moveq.l	#')',d1
		IOCS	_B_PUTC
@@:
		bsr	icrlf
		movem.l	(sp)+,d0-d2/a1
		rts

*----------------------------------------------------------------------------*
*  bZ[W\
*
*  in  : d0.w = ERROR CODE
*

IPRINT:
		movem.l	d0/a1,-(sp)
		add.w	d0,d0
		move.w	error_table(pc,d0.w),d0
		bsr	error_set
*		lea.l	errorx(pc,d0.w),a1
		IOCS	_B_PRINT
		movem.l	(sp)+,d0/a1
		rts

DPRINT:
		movem.l	d0/a1,-(sp)
		add.w	d0,d0
		move.w	error_table(pc,d0.w),d0
		bsr	error_set
*		lea.l	errorx(pc,d0.w),a1
		move.l	a1,-(sp)
		DOS	_PRINT
		addq.l	#4,sp
		movem.l	(sp)+,d0/a1
		rts

error_table:
		.dc.w	errorx-errorx
		.dc.w	error1-errorx
		.dc.w	error2-errorx
		.dc.w	error3-errorx
		.dc.w	error4-errorx
		.dc.w	error5-errorx
		.dc.w	error6-errorx
		.dc.w	error7-errorx
		.dc.w	error8-errorx
		.dc.w	error9-errorx

		.dc.w	error10-errorx
		.dc.w	error11-errorx
		.dc.w	error12-errorx
		.dc.w	error13-errorx
		.dc.w	error14-errorx
		.dc.w	error15-errorx
		.dc.w	error16-errorx
		.dc.w	error17-errorx
		.dc.w	error18-errorx
		.dc.w	error19-errorx

		.dc.w	error20-errorx
		.dc.w	error21-errorx
		.dc.w	error22-errorx
		.dc.w	error23-errorx
		.dc.w	error24-errorx
		.dc.w	error25-errorx
		.dc.w	error26-errorx
		.dc.w	error27-errorx
		.dc.w	error28-errorx
		.dc.w	error29-errorx

		.dc.w	error30-errorx
		.dc.w	error31-errorx
		.dc.w	error32-errorx
		.dc.w	error33-errorx
		.dc.w	error34-errorx
		.dc.w	error35-errorx

		.dc.w	error36-errorx
		.dc.w	error37-errorx
		.dc.w	error38-errorx
		.dc.w	error39-errorx
		.dc.w	error40-errorx

		.dc.w	error41-errorx
		.dc.w	error42-errorx
		.dc.w	error43-errorx
		.dc.w	error44-errorx
		.dc.w	error45-errorx

		.dc.w	error46-errorx
		.dc.w	errorx-errorx
		.dc.w	errorx-errorx
		.dc.w	errorx-errorx
		.dc.w	errorx-errorx

		.dc.w	error255-errorx
		.dc.w	errorx-errorx

error_set:
		lea.l	errorx(pc,d0.w),a1
		rts

errorx:		.dc.b	0
error1:		.dc.b	't@C܂.',0
error2:		.dc.b	't@C̍쐬Ɏs܂.',0
error3:		.dc.b	't@C̓ǂݍ݂Ɏs܂.',0
error4:		.dc.b	't@C݂̏Ɏs܂.',0
error5:		.dc.b	'XCb`̎wɌ肪܂.',0
error6:		.dc.b	'܂.',0
error7:		.dc.b	'fBXNeʂ܂.',0
error8:		.dc.b	't@Cw肵ĉ.',0
error9:		.dc.b	'łȂtH[}bgł.',0

error10:	.dc.b	'MPH: ',0
error11:	.dc.b	'ǂݍ݂܂.',0
error12:	.dc.b	'I܂D',0
error13:	.dc.b	'ŃZ[uł...',0
error14:	.dc.b	'      X SIZE =',0
error15:	.dc.b	'      Y SIZE =',0
error16:	.dc.b	'  擾 =',0
error17:	.dc.b	'  Kv =',0
error18:	.dc.b	' KB',0
error19:	.dc.b	'   ( X , Y ) =',0

error20:	.dc.b	'Z[uobt@̊mۂɎs܂.',0
error21:	.dc.b	'Warning: Z[uobt@̊SmۂɎsĂ܂.',0
error22:	.dc.b	'擾obt@TCY',0
error23:	.dc.b	'Kvobt@TCY',0
	.if	0
error24:	.dc.b	'-cu: ""ŊĂ܂.',0
	.endif
error25:	.dc.b	'OvZXG[ł.',0
error26:	.dc.b	'OtBbNVRAMgpł.',0
error27:	.dc.b	0	* 'WJƊOvZXWJ̋͂ł܂.',0
error28:	.dc.b	0	* ' OFMT  Start Point   Area      File Size    Ratio  FileName',0
error29:	.dc.b	0	* '------ ----------- --------- ------------- ------ -----------',0

error30:	.dc.b	'wb_قȂ܂.',0
error31:	.dc.b	'T|[gĂȂ`ł.',0
error32:	.dc.b	'256Fɂ͑ΉĂ܂.',0
error33:	.dc.b	'摜TCYE𒴂Ă܂.',0
error34:	.dc.b	'XWCXTCY 8hbgPʂɂȂĂ܂.',0
error35:	.dc.b	'HǴC200line摜ɑΉĂ܂.',0

error36:	.dc.b	'16FȊO͑ΉĂ܂.',0
error37:	.dc.b	'OFMTƓtH[}bg̓Ro[g܂.',0
error38:	.dc.b	'-s: ʃ[hႢ܂.',0
error39:	.dc.b	'-s: sȃZ[uWw肳܂.',0
error40:	.dc.b	'̊JɎs܂.',0

error41:	.dc.b	'fBNgł.',0
	.if	0
error42:	.dc.b	'Human68k̃o[WÂ܂. v3.00ȍ~gpĉ.',0
	.endif
error43:	.dc.b	'16,256FȊO͑ΉĂ܂.',0
error44:	.dc.b	'EWarning: f[^Ă܂.',0
error45:	.dc.b	'kBMP(RLE)ɂ͑ΉĂ܂.',0

error46:	.dc.b	'XWCXTCY 4hbgPʂɂȂĂ܂.',0

	.if	1
error24:
error42:
	.endif
error255:
		.dc.b	'VXeG[Ȃ̂. MPH2̃oỎ\Ȃ̂. ',CRLF
		.dc.b	'̃G[o󋵂񍐂ĂƊ̂. ',0
		.even


		.end

* End of File --------------------------------- *
