
		.include	mph.h
		.include	doscall.mac

		.xdef	skip_mac_binary
		.xdef	getc
		.xdef	getw
		.xdef	getw_intel
		.xdef	getl_intel

		.xref	icrlf
		.xref	ERROR


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*-
*  MACoCi[

skip_mac_binary:
		tst.b	_mac_binary(a5)
		beq	@f
		move.w	#0,-(sp)
		move.l	#$80,-(sp)
		move.w	_file(a5),-(sp)
		DOS	_SEEK
		addq.l	#8,sp
@@:		rts

*-
*  PoCgǂ

getc:
		move.w	_file(a5),-(sp)
		DOS	_FGETC
		addq.l	#2,sp
		tst.l	d0
		bmi	load_error
		rts

load_error:				* ɔł邱Ƃ͒ʏ킠肦Ȃ
		moveq.l	#3,d0
		suba.l	a1,a1
		bsr	ERROR
		move.w	#3,-(sp)
		DOS	_EXIT2

*-
*  P[hǂ

getw:
		bsr	getc
		lsl.w	#8,d0
		move.w	d0,-(sp)
		bsr	getc
		move.b	d0,1(sp)
		move.w	(sp)+,d0
		rts

getw_intel:
		bsr	getw
		rol.w	#8,d0
		rts

*-
*  PO[hǂ

getl:
		move.l	d1,-(sp)
		bsr	getc
		move.b	d0,-(sp)
		move.w	(sp)+,d1
		bsr	getc
		move.b	d0,d1
		swap.w	d1
		bsr	getc
		move.b	d0,-(sp)
		move.w	(sp)+,d1
		bsr	getc
		move.b	d0,d1
		move.l	d1,d0
		move.l	(sp)+,d1
		rts

getl_intel:
		bsr	getl		* 1 2 3 4
		rol.w	#8,d0		* 1 2 4 3
		swap	d0		* 4 3 1 2
		rol.w	#8,d0		* 4 3 2 1
		rts

	.end
