		.title	MPH3 Miscellaneous routine. written by Herzen


* Include File -------------------------------- *

		.include	mph.h
		.include	mph_lib.h
		.include	mph_misc.h
		.include	fefunc.mac
		.include	doscall.mac
		.include	iocscall.mac


* Global Symbol ------------------------------- *

		.xref	IPRINT
		.xref	ERROR
		.xref	con_on
		.xref	con_off
		.xref	error_src


* Fixed Number -------------------------------- *

LF:		.equ	$0a
CR:		.equ	$0d


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*------------------------------------------------------------------------------*
*  dstfilet@CtZbg[`
*

fdate_set::
		bsr	con_on
		moveq	#1,d6
		move	#1,-(sp)
		pea	(_dstfile,a5)
		DOS	_OPEN
		addq.l	#6,sp
		bsr	con_off
	.if	1
		moveq	#-68,d1
		cmp.l	d0,d1
		beq	open_error_68
	.endif
		move.l	d0,d1
		bmi	error_src

		bsr	fdate_set_sub

		move	d1,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		rts
open_error_68:
		moveq	#-1,d0
		rts

fdate_set_sub::
		move.l	(_src_fdate,a5),-(sp)
		move	d1,-(sp)
		DOS	_FILEDATE
		addq.l	#6,sp
		rts

*------------------------------------------------------------------------------*
*  srcfilet@Ct擾[`
*

fdate_get::
		bsr	con_on
		moveq	#1,d6
		clr	-(sp)
		pea	(_srcfile,a5)
		DOS	_OPEN
		addq.l	#6,sp
		bsr		con_off
	.if	1
		moveq	#-68,d1
		cmp.l	d0,d1
		beq	open_error_68
	.endif
		move.l	d0,d1
		bmi	error_src

		bsr	fdate_get_sub
		move.l	d0,(_src_fdate,a5)

		move	d1,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		moveq	#0,d0
		rts

fdate_get_sub::
		clr.l	-(sp)
		move	d1,-(sp)
		DOS	_FILEDATE
		addq.l	#6,sp
		rts

*------------------------------------------------------------------------------*
*  dstfile\[`
*

dstfile_disp::
		lea	(-256,sp),sp
		pea	(sp)
		clr.l	-(sp)
		pea	(envname_slash,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	dstfile_disp_no_slash
		cmpi	#'/'<<8,(sp)
		bne	dstfile_disp_no_slash

		move.l	a0,-(sp)
		lea	(_dstfile,a5),a0
		lea	(sp),a1
dstfile_disp_to_slash_loop:
		move.b	(a0)+,d0
		bmi	@f
		cmpi.b	#'\',d0
		bne	dstfile_disp_to_slash_copy
		move.b	#'/',(a1)+
		bra	dstfile_disp_to_slash_loop
@@:
		cmpi.b	#$a0,d0
		bcs	@f
		cmpi.b	#$e0,d0
		bls	dstfile_disp_to_slash_copy
@@:
		move.b	d0,(a1)+
		move.b	(a0)+,d0
dstfile_disp_to_slash_copy:
		move.b	d0,(a1)+
		bne	dstfile_disp_to_slash_loop
		
		lea	(sp),a1
		IOCS	_B_PRINT

		movea.l	(sp)+,a0
		lea	(256,sp),sp
		bra	@f
dstfile_disp_no_slash:
		lea	(256,sp),sp

		lea	(_dstfile,a5),a1
		IOCS	_B_PRINT
@@:
		moveq	#13,d0
		bsr	IPRINT
		bra	icrlf

envname_slash:
		.dc.b	'SLASH',0
		.even


*------------------------------------------------------------------------------*
*  dstfilet@CTCY擾[`
*

dstfile_size:
		movem.l	d1-d2,-(sp)
		move.w	#0,-(sp)
		pea.l	_dstfile(a5)
		DOS	_OPEN
		addq.l	#6,sp
		move.w	d0,d2
		move.w	#2,-(sp)
		pea.l	0.w
		move.w	d2,-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		move.l	d0,d1
		move.w	d2,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		move.l	d1,d0
		movem.l	(sp)+,d1-d2
		rts


*------------------------------------------------------------------------------*
*  srcfile擾[`
*
*  (l) 炩߁C_NAMECKC_FILES(_NFILES)Ă.
*

srcfile_get:
		lea.l	_srcfile(a5),a0
		lea.l	_nameck_buf(a5),a1	* srcfilẽpX
		bsr	strcpy
		lea.l	_files_fname(a5),a1	* srcfilẽt@C
		bsr	strcpy
* Q4D 쐬
		lea.l	_srcfile_q4d(a5),a0
		lea.l	_nameck_buf(a5),a1
		bsr	strcpy

		pea.l	_nameck_buf2(a5)
		pea.l	_srcfile(a5)
		DOS	_NAMECK
		addq.l	#8,sp
		lea.l	_nameck_fname2(a5),a1	* srcfile̎t@C
		bsr	strcpy

	.irpc	char,'.Q4D'
		move.b	#'&char',(a0)+
	.endm

		clr.b	(a0)
		rts


*------------------------------------------------------------------------------*
*  dstfile擾[`
*

dstfile_get:
		pea.l	_nameck_buf2(a5)
		pea.l	_files_fname(a5)
		DOS	_NAMECK
		addq.l	#8,sp
		lea.l	_dstfile(a5),a0
		lea.l	_dstpath(a5),a1
		bsr	strcpy
		lea.l	_nameck_fname2(a5),a1	* srcfile̎t@C
		bsr	strcpy
		movea.l	_ext_table_addr(a5),a1
		move.w	_dst(a5),d0
		add.w	d0,d0
		add.w	d0,d0
		lea.l	0(a1,d0.w),a1
		tst.b	_ext_ofmt_flag(a5)
		beq	@f
		lea.l	_ext_ofmt(a5),a1
@@:		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		clr.b	(a0)
* IPR 쐬
		lea.l	_dstfile_ipr(a5),a0
		lea.l	_dstpath(a5),a1
		bsr	strcpy
		lea.l	_nameck_fname2(a5),a1
		bsr	strcpy
	.irpc	char,'.IPR'
		move.b	#'&char',(a0)+
	.endm
		clr.b	(a0)
* RGB 쐬
		tst.b	_makeRGBflag(a5)
		beq	dst_file_get_end
		lea.l	_rgbfile(a5),a0
		lea.l	_dstpath(a5),a1
		bsr	strcpy
		lea.l	_nameck_fname2(a5),a1
		bsr	strcpy
	.irpc	char,'.RGB'
		move.b	#'&char',(a0)+
	.endm
		clr.b	(a0)
dst_file_get_end:
		rts

* NAMECK sĂ.
dstfile_get_saver:
		lea.l	_nameck_fname(a5),a1
		lea.l	_files_fname(a5),a0
		bsr	strcpy
		lea.l	_nameck_ext(a5),a1
		bsr	strcpy
		tst.b	_dstpath(a5)
		bne	@f
		lea.l	_dstpath(a5),a0
		lea.l	_nameck_buf(a5),a1
		bsr	strcpy
@@:		bra	dstfile_get


*------------------------------------------------------------------------------*
*  srcfile폜[`
*

srcfile_delete:
		tst.b	_DELflag(a5)
		beq	@f
		pea.l	_srcfile(a5)
		DOS	_DELETE
		addq.l	#4,sp
@@:		rts


*------------------------------------------------------------------------------*
*  Ԍv
*

*__IDIV		equ	$fe09
*__IUSING	equ	$fe18

* ʓ|قƂǂ̂܂(^^;
*	original program by cqK
*	modified program by Herzen

time_disp_init:
	tst.b	_time_flag(a5)
	beq	@f
	movem.l	d0-d1,-(sp)
	IOCS	_ONTIME		* vJn
	movem.l	d0/d1,_time(a5)
	movem.l	(sp)+,d0-d1
@@:	rts

time_disp:
	tst.b	_time_flag(a5)
	beq	@f

	movem.l	d0-d3/a0-a1,-(sp)
	IOCS	_ONTIME		* vI

	lea.l	_commentx(a5),a0

	movem.l	_time(a5),d2/d3	*JnƂ̍
	sub.l	d3,d1
	sub.l	d2,d0
	bcc	skip
	addq.l	#1,d1
	addi.l	#24*3600*100,d0

skip:	move.l	d0,d2
	move.l	d1,d0

	moveq.l	#5,d1		*
	FPACK	__IUSING
	move.b	#':',(a0)+
	movea.l	a0,a1

	move.l	d2,d0		*
	move.l	#3600*100,d1
	FPACK	__IDIV
	move.l	d1,d2
	moveq.l	#2,d1
	FPACK	__IUSING
	move.b	#':',(a0)+

	move.l	d2,d0		*
	move.l	#60*100,d1
	FPACK	__IDIV
	move.l	d1,d2
	moveq.l	#2,d1
	FPACK	__IUSING
	move.b	#':',(a0)+

	move.l	d2,d0		*b
	moveq.l	#100,d1
	FPACK	__IDIV
	move.l	d1,d2
	moveq.l	#2,d1
	FPACK	__IUSING
	move.b	#'.',(a0)+

	move.l	d2,d0		*1/100b
	FPACK	__IUSING

	move.b	#13,(a0)+
	move.b	#10,(a0)+
	clr.b	(a0)

zloop:	move.b	(a1)+,d0	*󔒁'0'ϊ
	beq	time_disp_end
	cmp.b	#' ',d0
	bne	zloop
	move.b	#'0',-1(a1)
	bra	zloop

time_disp_end:
	bsr	con_on
	lea.l	_commentx(a5),a1
	IOCS	_B_PRINT
	bsr	con_off
	movem.l	(sp)+,d0-d3/a0-a1
@@:	rts


*------------------------------------------------------------------------------*
*  [N\[`
*

	.ifdef __DEBUG__
work_disp::
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	con_on
		lea	(mal,pc),a1
		IOCS	_B_PRINT
		move	(_malloc,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(dep,pc),a1
		IOCS	_B_PRINT
		move	(_depend,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(src,pc),a1
		IOCS	_B_PRINT
		move	(_src,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(dst,pc),a1
		IOCS	_B_PRINT
		move	(_dst,a5),d0
		bsr	prtdec
		bsr	icrlf
* -
		lea	(buff,pc),a1
		IOCS	_B_PRINT
		move.l	(_buff_addr,a5),d0
		bsr	HEXOUT

		lea	(buffs,pc),a1
		IOCS	_B_PRINT
		move.l	(_buff_size,a5),d0
		bsr	HEXOUT

		lea	(save,pc),a1
		IOCS	_B_PRINT
		move.l	(_save_addr,a5),d0
		bsr	HEXOUT

		lea	(save2,pc),a1
		IOCS	_B_PRINT
		move.l	(_save_addr2,a5),d0
		bsr	HEXOUT

		lea	(linewk,pc),a1
		IOCS	_B_PRINT
		move.l	(_linewk_addr,a5),d0
		bsr	HEXOUT

		lea	(slidewk,pc),a1
		IOCS	_B_PRINT
		move.l	(_slidewk_addr,a5),d0
		bsr	HEXOUT

		bsr	con_off
		movem.l	(sp)+,d0-d7/a0-a6
		rts

mal:		.dc.b	'_malloc =',0
dep:		.dc.b	'_depend =',0
src:		.dc.b	'   _src =',0
dst:		.dc.b	'   _dst =',0
buff:		.dc.b	'   _buff_addr =',0
buffs:		.dc.b	'   _buff_size =',0
save:		.dc.b	'   _save_addr =',0
save2:		.dc.b	'  _save_addr2 =',0
linewk:		.dc.b	' _linewk_addr =',0
slidewk:	.dc.b	'_slidewk_addr =',0

scolum:		.dc.b	'  _scolum =',0
sline:		.dc.b	'   _sline =',0
colum:		.dc.b	'   _colum =',0
line:		.dc.b	'    _line =',0
ecolum:		.dc.b	'  _ecolum =',0
eline:		.dc.b	'   _eline =',0
		.even

size_disp::
		movem.l	d0-d7/a0-a6,-(sp)
		bsr	con_on

		lea	(scolum,pc),a1
		IOCS	_B_PRINT
		move	(_scolum,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(sline,pc),a1
		IOCS	_B_PRINT
		move	(_sline,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(colum,pc),a1
		IOCS	_B_PRINT
		move	(_colum,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(line,pc),a1
		IOCS	_B_PRINT
		move	(_line,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(ecolum,pc),a1
		IOCS	_B_PRINT
		move	(_ecolum,a5),d0
		bsr	prtdec
		bsr	icrlf

		lea	(eline,pc),a1
		IOCS	_B_PRINT
		move	(_eline,a5),d0
		bsr	prtdec
		bsr	icrlf

		bsr	con_off
		movem.l	(sp)+,d0-d7/a0-a6
		rts
	.endif

		.end

* End of File --------------------------------- *
