.comment comments *-------------------------------------------------------------*
|										|
|	Pi(16/256) Graphic Loader for over1024/512				|
|										|
|					original program by Ȃ		|
|					rewrited program by Herzen		|
|										|
|		   xpi_load.s/pi8ld.x Copyright (c) 1990,91 Ȃ		|
|										|
|				--       based on xpi_load.s v1.08  --		|
|				--                   pi8ld.x v0.5   --		|
|				--  modified for pi_load.has v2.04  --		|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.include	config.h

		.xdef	pi_header_read__
		.xdef	pi_decode__

		.xref	skip_mac_binary
		.xref	getc
		.xref	getw
		.xref	comment_get


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* Pi(16/256)摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
pi_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		cmp.w	#8,_color(a5)
		beq	pi_decode_256

		bsr	color_initialize	* J[e[u
		lea	data(pc),a6		* a6 = [N
		move.l	_colum(a5),colum(a6)	* colum(a6),line(a6) = cETCY
		move.l	_buff_addr(a5),d0
		sub.l	#FOR_PI,d0
		move.l	d0,gbuff(a6)		* gbuff(a6) = zGRAM2lineO
		move.l	a1,a5			* a5 = READDATAAhX
		move.w	(a5)+,d6		* d6.w = READDATA
		moveq.l	#15,d7			* d7.w = JE^(l15)
		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts

pi_decode_256:
		lea	data(pc),a6		* a6 = [N
		move.l	a1,d0
		sub.l	#FOR_PI256,d0
		move.l	d0,color_table(a6)	* color_table(a6) = J[e[uAhX
		bsr	color_initialize256	* J[e[u
		move.l	_colum(a5),colum(a6)	* colum(a6),line(a6) = cETCY
	.ifdef	PiH
		move.l	_buff_addr256(a5),d0
	.else
		move.l	_buff_addr(a5),d0
	.endif
		sub.l	#FOR_PI,d0
		move.l	d0,gbuff(a6)		* gbuff(a6) = zGRAM2lineO
		move.l	a1,a5			* a5 = READDATAAhX
		move.w	(a5)+,d6		* d6.w = READDATA
		moveq.l	#15,d7			* d7.w = JE^(l15)
		bsr	expand256
		movem.l	(sp)+,d3-d7/a3-a6
		rts

*----------------------------------------------------------------------------*
*
* Piwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*        EMAC binary ΉD
*
*----------------------------------------------------------------------------*

header_read:
		bsr	getc
		cmp.b	#'P',d0
		bne	@f
		bsr	getc
		cmp.b	#'i',d0
		beq	pi_header_cont02
@@:
		move.w	#0,-(sp)
		pea.l	0.w
		move.w	_file(a5),-(sp)
		.dc.w	$FF42		* DOS	__SEEK
		addq.l	#8,sp
		bsr	skip_mac_binary
		bra	pi_header_cont

pi_header_read__:
		bsr	skip_mac_binary
pi_header_cont:
		moveq.l	#0,d7
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'P',d0
		bne	error_
		bsr	getc
		cmp.b	#'i',d0
		bne	error_
		moveq.l	#0,d1
pi_header_cont02:

		bsr	comment_get

com1		bsr	getc
		tst.b	d0
		bne	com1

		moveq.l	#0,d3
		bsr	getc
		cmp.b	#0,d0
		beq	head_reada
		moveq.l	#31,d6
		cmp.b	#$80,d0
		bne	error_
		moveq.l	#1,d3
head_reada
		bsr	getc			* 䗦ritu0
		move.w	d0,ritu0(a5)
		bsr	getc			* 䗦ritu1
		move.w	d0,ritu1(a5)
		tst.w	d0
		beq	chk256
		move.w	ritu0(a5),d1
		beq	chk256
		cmp.w	d0,d1
		beq	chk256
		st.b	_200flag(a5)
		move.b	#'!',_PP_flag(a5)
chk256:
		bsr	getc
		ext.w	d0
		move.w	d0,_color(a5)

		bsr	getw
		bsr	getw			* @

		move.l	#0,_scolum(a5)

		bsr	getw			* @탆j[N
		subq.w	#1,d0
		bmi	head_read1
		move.w	d0,d1

		cmp.b	#4,d1
		bne	head_read2
		subq.w	#1,d1
		bsr	getc
		cmp.b	#1,d0
		bne	head_read2
		bsr	getw
		move.w	d0,_scolum(a5)
		bsr	getw
		move.w	d0,_sline(a5)
		bra	head_read1

head_read2
		bsr	getc			* @\
		dbra	d1,head_read2

head_read1
		bsr	getw			* X width
		move.w	d0,_colum(a5)
		bsr	getw
		move.w	d0,_line(a5)		* Y width

		lea.l	_tmp(a5),a4
		tst.w	d3
		beq	@f
		bsr	def_pal
		bra	head_cont
@@
		moveq.l	#1,d1
		move.w	_color(a5),d0
		lsl.l	d0,d1
		move.w	d1,d0
		add.w	d1,d1
		add.w	d0,d1
		subq.w	#1,d1
**		move.w	#3*16-1,d1
head_read0
		bsr	getc
		move.b	d0,(a4)+
		dbra	d1,head_read0
head_cont
		bsr	set_pal

		move.w	_colum(a5),d0
		subq.w	#1,d0
		add.w	_scolum(a5),d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		add.w	_sline(a5),d0
		move.w	d0,_eline(a5)

		moveq.l	#0,d0
		rts

def_pal
		moveq.l	#0,d0
def_pal0
		move.w	#15,d1
		move.w	#15,d2
		move.w	#15,d3

		btst.l	#1,d0
		bne	def_pal1
		clr.w	d1
def_pal1
		btst.l	#2,d0
		bne	def_pal2
		clr.w	d2
def_pal2
		btst.l	#0,d0
		bne	def_pal3
		clr.w	d3
def_pal3
		cmp.w	#8,d0
		bge	def_pal4
		and.w	#7,d1
		and.w	#7,d2
		and.w	#7,d3
def_pal4
		lsl.w	#4,d1
		lsl.w	#4,d2
		lsl.w	#4,d3
		move.b	d1,(a4)+
		move.b	d2,(a4)+
		move.b	d3,(a4)+
		addq.w	#1,d0
		cmp.w	#16,d0
		blt	def_pal0
		moveq.l	#0,d0
		rts

*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

set_pal
		tst.w	_palet(a5)
		bne	set_pal_end
		movem.l	d0-d4/a0-a1,-(sp)
		lea.l	_tmp(a5),a0
		lea	_pal_buf(a5),a1
		moveq.l	#1,d4
		move.w	_color(a5),d0
		lsl.l	d0,d4
		subq.w	#1,d4
set_pal_lop
		moveq.l	#0,d1
		move.b	(a0)+,d1
		moveq.l	#0,d0
		move.b	(a0)+,d0
		moveq.l	#0,d2
		move.b	(a0)+,d2
		lsl.w	#8,d0
		and.w	#$f800,d0
		lsl.w	#3,d1
		and.w	#$7c0,d1
		lsr.w	#2,d2
		and.w	#$3f,d2
		or.w	d1,d0
		or.w	d2,d0
		move.w	d0,(a1)+
		dbra	d4,set_pal_lop
		movem.l	(sp)+,d0-d4/a0-a1
set_pal_end:
		rts

error_:
		moveq.l	#-1,d0
		rts


*----------------------------------------------------------------------------*
*
* 16/256摜WJC
*
*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
*  256FWJC
*----------------------------------------------------------------------------*

expand_one256:
	movea.l	gbuff(a6),a2
	lea.l	FOR_PI(a2),a2
	move.w	line(a6),d4
	mulu.w	colum(a6),d4
	add.l	a2,d4
	clr.w	d0
one256lop:
	lea.l	ret_one_256(pc),a4
	bra	read_color256
ret_one_256:
	move.b	d0,(a2)+
	cmpa.l	d4,a2
	blt	one256lop
	rts

expand256
	move.w	colum(a6),d0
	cmp.w	#2,d0
	ble	expand_one256
	neg.w	d0
	lea.l	L0005a2(pc),a1
	move.w	d0,2(a1)
	addq.w	#1,d0
	lea.l	L000558(pc),a1
	move.w	d0,2(a1)
	subq.w	#2,d0
	lea.l	L000548(pc),a1
	move.w	d0,2(a1)
	addq.w	#1,d0
	add.w	d0,d0
	lea.l	L000568(pc),a1
	move.w	d0,2(a1)
	movea.l	gbuff(a6),a2
	clr.w	d3
	bsr	read_color256
	move.w	d3,-(sp)
	bsr	read_color256
	move.w	d3,d0
	move.w	(sp)+,d1
	move.w	#FOR_PI/2-1,d2
expand256_0:
	move.b	d1,(a2)+
	move.b	d0,(a2)+
	dbra	d2,expand256_0
	move.l	a2,d4
	move.w	line(a6),d5
	mulu.w	colum(a6),d5
	add.l	d5,d4
	moveq.l	#$ff,d5
	bra	L0004c2

L000474:
	move.b	-1(a2),d3
L000478:
	bsr	read_color256
	move.b	d3,(a2)+
	bsr	read_color256
	move.b	d3,(a2)+
	add.w	d6,d6
	dbcc	d7,L000478
	dbcs	d7,L0004ae
	bcc	L0004a0
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L000478

L0004a0:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L0004ae:
	moveq.l	#$ff,d5
	cmpa.l	d4,a2
	blt	L0004c2
	bra	L000766

L0004b8:
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
L0004bc:
	cmpa.l	d4,a2
	bge	L000766
L0004c2:
	add.w	d6,d6
	dbcs	d7,L000570
	dbcc	d7,L0004ee
	bcs	L0004e0
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L000570

L0004e0:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L0004ee:
	add.w	d6,d6
	dbcs	d7,L000560
	dbcc	d7,L000518
	bcs	L00050a
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L000560

L00050a:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L000518:
	add.w	d6,d6
	dbcs	d7,L000550
	dbcc	d7,L000542
	bcs	L000534
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L000550

L000534:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L000542:
	tst.w	d5
	beq	L000474
L000548:
	lea.l	-$0281(a2),a4
	moveq.l	#$00,d5
	bra	L0005c2

L000550:
	cmp.w	#$0001,d5
	beq	L000474
L000558:
	lea.l	-$027f(a2),a4
	moveq.l	#$01,d5
	bra	L0005c2

L000560:
	cmp.w	#$0002,d5
	beq	L000474
L000568:
	lea.l	-$0500(a2),a4
	moveq.l	#$02,d5
	bra	L0005c2

L000570:
	add.w	d6,d6
	dbcs	d7,L0005aa
	dbcc	d7,L00059a
	bcs	L00058c
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0005aa

L00058c:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L00059a:
	cmp.w	#$0003,d5
	beq	L000474
L0005a2:
	lea.l	-$0280(a2),a4
	moveq.l	#$03,d5
	bra	L0005c2

L0005aa:
	cmp.w	#$0004,d5
	beq	L000474
	lea.l	-$0002(a2),a4
	moveq.l	#$04,d5
	move.b	-$0001(a2),d0
	cmp.b	(a4),d0
	beq	L0005c2
	subq.l	#2,a4
L0005c2:
	add.w	d6,d6
	dbcs	d7,L0004b8
	dbcc	d7,L0005ee
	bcs	L0005e0
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0004b8

L0005e0:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L0005ee:
	add.w	d6,d6
	dbcc	d7,L000650
	dbcs	d7,L000618
	bcc	L00060a
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L000650

L00060a:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L000618:
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	add.w	d6,d6
	dbcs	d7,L0004bc
	dbcc	d7,L0004b8
	bcs	L00063e
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0004bc

L00063e:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0004b8

L000650:
	add.w	d6,d6
	dbcc	d7,L0006ee
	dbcs	d7,L00067c
	bcc	L00066e
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0006ee

L00066e:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L00067c:
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	add.w	d6,d6
	dbcs	d7,L0006be
	dbcc	d7,L0006b6
	bcs	L0006a8
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0006be

L0006a8:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L0006b6:
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
L0006be:
	add.w	d6,d6
	dbcs	d7,L0004bc
	dbcc	d7,L0004b8
	bcs	L0006dc
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0004bc

L0006dc:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0004b8

L0006ee:
	move.w	d7,d0
L0006f0:
	add.w	d6,d6
	dbcc	d7,L0006f0
	dbcs	d7,L00071a
	bcc	L00070c
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
	bra	L0006f0

L00070c:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L00071a:
	sub.w	d7,d0
	and.w	#$000f,d0
	addq.w	#2,d0
	moveq.l	#$01,d1
	lsl.l	d0,d1
	cmp.w	#$000e,d0
	ble	L000744
	move.w	d0,d2
	moveq.l	#$0e,d0
	bsr	load_bit
	and.l	#$0000ffff,d0
	sub.w	#$000e,d2
	lsl.l	d2,d0
	add.l	d0,d1
	move.w	d2,d0
L000744:
	bsr	load_bit
	and.l	#$0000ffff,d0
	add.l	d1,d0
	subq.l	#1,d0
L000752:
	move.b	(a4)+,(a2)+
	move.b	(a4)+,(a2)+
	dbra	d0,L000752
	sub.l	#$00010000,d0
	bmi	L0004bc
	bra	L000752

L000766:
	rts

*----------------------------------------------------------------------------*
*	256FJ[e[ȕ

color_initialize256:
	movea.l	color_table(a6),a0
	moveq.l	#1,d1
col256_ini0:
	move.w	d1,d0
	move.w	#255,d2
col256_ini1:
	and.w	#$00ff,d0
	move.b	d0,(a0)+
	addq.l	#1,d0
	dbra	d2,col256_ini1
	addq.l	#1,d1
	cmp.w	#256,d1
	ble	col256_ini0
	rts

*----------------------------------------------------------------------------*

read_color256:
	and.l	#$000000ff,d3
	movea.l	color_table(a6),a0
	adda.w	#$00ff,a0
	lsl.w	#8,d3
	adda.l	d3,a0
	add.w	d6,d6
	dbcs	d7,L0007ce
	dbcc	d7,L0007c8
	bcs	L0007ba
	moveq.l	#15,d7
	move.w	(a5)+,d6
	bra	L0007ce

L0007ba:
	moveq.l	#$0f,d7
	move.w	(a5)+,d6
L0007c8:
	moveq.l	#1,d0
	moveq.l	#0,d3
	bra	L000806

L0007ce:
	moveq.l	#$00,d3
L0007d0:
	addq.l	#1,d3
	cmp.w	#7,d3
	beq	L000800
	add.w	d6,d6
	dbcc	d7,L0007d0
	dbcs	d7,L000800
	bcc	L0007d6
	moveq.l	#15,d7
	move.w	(a5)+,d6
	bra	L0007d0
L0007d6:
	moveq.l	#15,d7
	move.w	(a5)+,d6
L000800:
	moveq.l	#1,d0
	lsl.w	d3,d0
	exg.l	d0,d3
L000806:
	bsr	load_bit
	add.w	d3,d0
	suba.w	d0,a0
	move.b	(a0),d3
	lea.l	1(a0),a1
	subq.w	#1,d0
	bmi	L00081e
@@:	move.b	(a1)+,(a0)+
	dbra	d0,@b
	move.b	d3,(a0)
L00081e:
	rts

*----------------------------------------------------------------------------*
*	rbgǂݍ

load_bit:
	sub.w	d0,d7
	blt	load_bit_a
	swap.w	d6
	clr.w	d6
	rol.l	d0,d6
	move.w	d6,d0
	swap.w	d6
	rts

load_bit_a:
	add.w	d0,d7
	addq.w	#1,d7
	and.l	#$0000ffff,d6
	lsl.l	d7,d6
	sub.w	d7,d0
	move.w	d0,d7
	move.w	(a5)+,d6
	lsl.l	d7,d6
	neg.w	d7
	add.w	#15,d7
	move.l	d6,d0
	swap.w	d0
	rts




*----------------------------------------------------------------------------*
*  16FWJC
*----------------------------------------------------------------------------*

expand_one
		move.l	gbuff(a6),a2
		lea	FOR_PI(a2),a2
		move.w	line(a6),d4
		mulu	colum(a6),d4
		add.l	a2,d4
		clr.w	d0
expand_one_lop
		lea	ret_one(pc),a4
		bra	read_color
ret_one
		move.b	d0,(a2)+
		cmp.l	d4,a2
		blt	expand_one_lop
		rts

expand:
		move.w	colum(a6),d0
		lea	rewrite_table(pc),a0
expandP2
		move.w	(a0)+,d2
		beq	expandP3
		move.w	(a0)+,d1
		add.w	d0,d1
		neg.w	d1
		move.w	d1,2(a6,d2.w)
		bra	expandP2
expandP3
		add.w	d0,d0
		neg.w	d0
		move.w	d0,pat6-data+2(a6)
		move.w	d0,pat15-data+2(a6)
		move.w	colum(a6),d0
		and.w	#1,d0
		beq	expandP4
		move.b	#OPload_len-patp0-2,patp0-data+3(a6)
		move.b	#OPload_lenx-patp1-2,patp1-data+3(a6)
		bra	expandP5
expandP4
		move.b	#Pload_len-patp0-2,patp0-data+3(a6)
		move.b	#Pload_lenx-patp1-2,patp1-data+3(a6)
expandP5
		cmp.w	#2,colum(a6)
		ble	expand_one

		move.l	gbuff(a6),a2			*ɓWJ摜f[^AhX
		clr.w	d0
		lea	ret0(pc),a4
		bra	read_color
ret0
		move.w	d0,d1
		lea	ret1(pc),a4
		bra	read_color
ret1
		move.w	#FOR_PI/2-1,d2		* 1024 fixed
expand0
		move.b	d1,(a2)+
		move.b	d0,(a2)+
		dbra	d2,expand0
		move.l	a2,d4
		move.w	line(a6),d5

		mulu	colum(a6),d5
		add.l	d5,d4			* d4=gbuffi摜GhAhXj
		moveq.l	#-1,d5
		bra.b	expand_lop0
expand_lop
		cmpa.l	d4,a2
		bge	expand_end		* a2d4Cexpand_end 
expand_lop0
		sub.w	#2,d7
		bge	expand9			* d7  0  vX ł expand9 

		addq.w	#1,d7
		beq.b	expand100

		move.w	#14,d7
		add.l	d6,d6

		move.w	(a5)+,d6
		add.l	d6,d6
		move.l	d6,d0
		swap	d0
		and.w	#3,d0
		cmp.w	#3,d0
		bne	expand1
		bra	expand200
expand100
		move.w	#15,d7
		add.l	d6,d6
		add.l	d6,d6

		move.w	(a5)+,d6

		move.l	d6,d0
		swap	d0
		and.w	#3,d0
		cmp.w	#3,d0
		bne	expand1
expand200
** 1 bit load
		add.w	d6,d6			* rol.w #1,d6 ̍
		dbcc	d7,ex0			* d70CrbgPCex0 
		dbcs	d7,ex3			* d70CrbgPŖ΁Cex3 
						* d7͂ -1 .
		bcc.b	ex2			* rbgPŖ΁Cex2
		moveq.l	#15,d7

		move.w	(a5)+,d6
ex0
		cmp.w	#4,d5			* OƈʒuH
		beq	exx
		moveq.l	#4,d5			* ʒuS
		bra	load_length
ex2
		moveq.l	#15,d7

		move.w	(a5)+,d6
ex3
		cmp.w	#3,d5			* OƈʒuH
		beq	exx
		moveq.l	#3,d5			* ʒuR
		bra	load_length
expand9
		rol.w	#2,d6			* ʒum肽
		move.w	d6,d0
expand10
		and.w	#3,d0
		cmp.w	#3,d0
		beq	expand200		* ʒuRorSł̂ŁC1bit load 
expand1
		cmp.w	d5,d0			* OƈʒuH
		bne	expand3
exx						* OƓCFf[^ł
		moveq.l	#-1,d5			* Ⴄ̂Ȃhf[^hł
		moveq.l	#0,d0

		lea	ret3(pc),a3
		move.l	a3,d2
		lea	ret2(pc),a3
expand21
		move.b	-1(a2),d0
expand20
		move.l	a3,a4
*	bra	read_color
		lsl.w	#5,d0
		lea	30(a6,d0.w),a0

		add.w	d6,d6
		dbcc	d7,abc0
		dbcs	d7,read_col0
		bcc	re0
		moveq.l	#15,d7

		move.w	(a5)+,d6
abc0
		add.w	d6,d6
		dbcs	d7,abc2
		dbcc	d7,abc5
		bcs	abc4

		moveq.l	#15,d7

		move.w	(a5)+,d6
abc2
		move.w	(a0),d0
		jmp	(a4)
abc4
		moveq.l	#15,d7

		move.w	(a5)+,d6
abc5
		move.l	-2(a0),d0
		swap	d0
		move.l	d0,-2(a0)
*--
ret2
		move.b	d0,(a2)+
		move.l	d2,a4
*	bra	read_color
		lsl.w	#5,d0
		lea	30(a6,d0.w),a0

		add.w	d6,d6
		dbcc	d7,abc00
		dbcs	d7,read_col0
		bcc	re0
		moveq.l	#15,d7

		move.w	(a5)+,d6
abc00
		add.w	d6,d6
		dbcs	d7,abc20
		dbcc	d7,abc50
		bcs	abc40

		moveq.l	#15,d7

		move.w	(a5)+,d6
abc20
		move.w	(a0),d0
		jmp	(a4)
abc40
		moveq.l	#15,d7

		move.w	(a5)+,d6
abc50
		move.l	-2(a0),d0
		swap	d0
		move.l	d0,-2(a0)
ret3
		move.b	d0,(a2)+
** 1 bit load
		add.w	d6,d6
		dbcc	d7,expand20
		dbcs	d7,expand_lop
		bcc.b	ex20
		moveq.l	#15,d7

		move.w	(a5)+,d6
		bra	expand21
ex20
		moveq.l	#15,d7

		move.w	(a5)+,d6
		bra	expand_lop
expand3
		move.w	d0,d5
*
*	[h
*
load_length
		add.w	d6,d6
		dbcs	d7,expandx		* d70CrbgPłȂ΁Cexpandx 
						* d7  -1 
		dbcc	d7,load_len00
		bcc	load_len01		* d70CrbgPŖ΁Cload_len01 

		moveq.l	#15,d7

		move.w	(a5)+,d6
load_len00
		move.l	d7,d2
		dbra	d7,load_len0
load_len3
		moveq.l	#15,d7
		add.w	#16,d2

		move.w	d6,d0
		move.w	(a5)+,d6
		add.w	d0,d0
		bcc.b	load_len2
		subq.l	#1,d7
load_len0
		add.w	d6,d6
		dbcc	d7,load_len0
		bcs.b	load_len3
load_len2
		moveq.l	#1,d3
		sub.l	d7,d2
load_len4
		lsl.l	d2,d3
*
load_len5
		sub.w	d2,d7
		bge	load_len6

		add.w	d2,d7
		addq.w	#1,d7
		and.l	#$ffff,d6
		lsl.l	d7,d6
		sub.w	d7,d2
		move.w	d2,d7

		move.w	(a5)+,d6
		lsl.l	d7,d6
		neg.w	d7
		add.w	#15,d7
		move.l	d6,d2
		swap	d2
		add.w	d2,d3
		subq.l	#1,d3
		beq	expandx
		move.w	d5,d0
		add.w	d0,d0
		bra	patp0
*		jmp	Pload_len(pc,d0.w)
load_len6
		swap	d6
		clr.w	d6
		rol.l	d2,d6
		add.w	d6,d3
		swap	d6
load_len_end
**
		subq.l	#1,d3
		move.w	d5,d0
		add.w	d0,d0
patp0
		jmp	Pload_len(pc,d0.w)
OPload_len
		bra.b	expand_1
		bra.b	oexpand_2
		bra.b	expand_3d
		bra.b	oexpand_4
oexpand_5
pat1
		lea	-641(a2),a3
oexpand5_lop
		move.w	(a3)+,(a2)+
		dbra	d3,oexpand5_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	oexpand5_lop
*
oexpand_2
pat2
		lea	-640(a2),a3
oexpand2_lop
		move.b	(a3)+,(a2)+
		move.b	(a3)+,(a2)+
		dbra	d3,oexpand2_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	oexpand2_lop
**
oexpand_4
pat3
		lea	-639(a2),a3
oexpand4_lop
		move.w	(a3)+,(a2)+
		dbra	d3,oexpand4_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	oexpand4_lop
*--
Pload_len
		bra.b	expand_1
		bra.b	expand_2
		bra.b	expand_3
		bra.b	expand_4d
expand_5
pat4
		lea	-641(a2),a3
expand5_lop
		move.b	(a3)+,(a2)+
		move.b	(a3)+,(a2)+
		dbra	d3,expand5_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand5_lop
**
expand_3d	bra	expand_3
expand_4d	bra	expand_4
**
expand_1
		move.w	-2(a2),d0
		cmp.b	-2(a2),d0
		bne.b	expand11
expand10_lop
		move.w	d0,(a2)+
		dbra	d3,expand10_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand10_lop
expand11
		move.w	-4(a2),d1
expand11_lop
		move.w	d1,(a2)+
		dbra	d3,expand110
		sub.l	#$10000,d3
		bmi	expand_lop
expand110
		move.w	d0,(a2)+
		dbra	d3,expand11_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand11_lop
**
expand_2
pat5
		lea	-640(a2),a3
expand2_lop
		move.w	(a3)+,(a2)+
		dbra	d3,expand2_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand2_lop
**
expand_3
pat6
		lea	-1280(a2),a3
expand3_lop
		move.w	(a3)+,(a2)+
		dbra	d3,expand3_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand3_lop
**
expand_4
pat7
		lea	-639(a2),a3
expand4_lop
		move.b	(a3)+,(a2)+
		move.b	(a3)+,(a2)+
		dbra	d3,expand4_lop
		sub.l	#$10000,d3
		bmi	expand_lop
		bra.b	expand4_lop
**
expand_end
		rts
*-
load_len01
		moveq.l	#15,d7

		move.w	(a5)+,d6
*-
expandx
		move.w	d5,d0
		add.w	d0,d0
patp1
		jmp	Pload_lenx(pc,d0.w)
OPload_lenx
		bra.b	expand_1x
		bra.b	oexpand_2x
		bra.b	expand_3x
		bra.b	oexpand_4x
oexpand_5x
pat8
		move.w	-641(a2),(a2)+
		bra	expand_lop
oexpand_2x
pat9
		move.b	-640(a2),(a2)+
pat10
		move.b	-640(a2),(a2)+
		bra	expand_lop
oexpand_4x
pat11
		move.w	-639(a2),(a2)+
		bra	expand_lop

*--------------
Pload_lenx
		bra.b	expand_1x
		bra.b	expand_2x
		bra.b	expand_3x
		bra.b	expand_4x
expand_5x
pat12
		move.b	-641(a2),(a2)+
pat13
		move.b	-641(a2),(a2)+
		bra	expand_lop
expand_1x
		move.w	-2(a2),d0
		cmp.b	-2(a2),d0
		bne.b	expand_10x
		move.w	d0,(a2)+
		bra	expand_lop
expand_10x
		move.w	-4(a2),(a2)+
		bra	expand_lop
expand_2x
pat14
		move.w	-640(a2),(a2)+
		bra	expand_lop
expand_3x
pat15
		move.w	-1280(a2),(a2)+
		bra	expand_lop
expand_4x
pat16
		move.b	-639(a2),(a2)+
pat17
		move.b	-639(a2),(a2)+
		bra	expand_lop



*----------------------------------------------------------------------------*
*	16FJ[e[ȕ

color_initialize
		move.l	a0,-(sp)
		lea.l	data(pc),a0
		moveq.l	#1,d1
col_ini0
		move.w	d1,d0
		moveq.l	#16-1,d2
col_ini1
		and.w	#15,d0
		move.w	d0,(a0)+
		addq.l	#1,d0
		dbra	d2,col_ini1
		addq.l	#1,d1
		cmp.w	#16,d1
		ble	col_ini0
		move.l	(sp)+,a0
		rts

*----------------------------------------------------------------------------*
*	16Fǂݍ

read_color
		lsl.w	#5,d0
		lea	30(a6,d0.w),a0

		add.w	d6,d6
		dbcc	d7,re2
		dbcs	d7,read_col0
		bcc	re0
Xread_col
		moveq.l	#15,d7

		move.w	(a5)+,d6
re2
		add.w	d6,d6
		dbcs	d7,re40
		dbcc	d7,read_col3
		bcs	re41

		moveq.l	#15,d7

		move.w	(a5)+,d6
re40
		move.w	(a0),d0
		jmp	(a4)
re41
		moveq.l	#15,d7

		move.w	(a5)+,d6
read_col3
		move.l	-2(a0),d0
		swap	d0
		move.l	d0,-2(a0)
		jmp	(a4)
**
re0
		moveq.l	#15,d7

		move.w	(a5)+,d6
read_col0
		add.w	d6,d6
		dbcc	d7,read_col1
		dbcs	d7,recx0
		bcs	recx1
		moveq.l	#15,d7

		move.w	(a5)+,d6
recx0
		add.w	d6,d6
		dbcc	d7,read_col5
		dbcs	d7,recx4
		bcs.b	recx5

		moveq.l	#15,d7

		move.w	(a5)+,d6
recx4
		move.w	-4(a0),d0
		move.l	-2(a0),-4(a0)
		move.w	d0,(a0)
		jmp	(a4)
recx5
		moveq.l	#15,d7

		move.w	(a5)+,d6
read_col5
		move.w	-6(a0),d0
		move.l	-4(a0),-6(a0)
		move.w	(a0),-2(a0)
		move.w	d0,(a0)
		jmp	(a4)
recx1
		moveq.l	#15,d7

		move.w	(a5)+,d6
read_col1
		add.w	d6,d6
		dbcc	d7,rec0
		dbcs	d7,rec1
		bcc.b	rec2
		moveq.l	#15,d7

		move.w	(a5)+,d6
rec0
		subq.w	#3,d7
		bge.b	rec10

		addq.w	#4,d7
		and.l	#$ffff,d6
		lsl.l	d7,d6
		subq.w	#3,d7
		neg.w	d7

		move.w	(a5)+,d6
		lsl.l	d7,d6
		neg.w	d7
		add.w	#15,d7
		move.l	d6,d3
		swap	d3
		and.w	#7,d3
		bra	getcol
rec10
		rol.w	#3,d6
		moveq.l	#7,d3
		and.w	d6,d3
getcol
		add.w	d3,d3
		sub.w	d3,a0
		lea	-16(a0),a0
		lea	2(a0),a1
		move.w	(a0),d0
		neg.w	d3
		jmp	getcol1(pc,d3.w)

		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
getcol1
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.w	d0,(a0)
		jmp	(a4)
*-
rec2
		moveq.l	#15,d7

		move.w	(a5)+,d6
rec1
		sub.w	#2,d7
		bge.b	rec8

		addq.w	#1,d7
		beq.b	rec5

		move.w	#14,d7
		add.l	d6,d6

		move.w	(a5)+,d6
		add.l	d6,d6
		move.l	d6,d3
		swap	d3
		bra.b	rec9
rec5
		move.w	#15,d7
		add.l	d6,d6
		add.l	d6,d6

		move.w	(a5)+,d6
		move.l	d6,d3
		swap	d3
		bra.b	rec9
rec8
		rol.w	#2,d6
		move.w	d6,d3
rec9
		and.w	#3,d3
		add.w	d3,d3
		sub.w	d3,a0
		subq.l	#8,a0
		lea	2(a0),a1
		move.w	(a0),d0
		neg.w	d3
		jmp	getcolB(pc,d3.w)

		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
		move.w	(a1)+,(a0)+
getcolB
		move.l	(a1)+,(a0)+
		move.l	(a1)+,(a0)+
		move.w	d0,(a0)
		jmp	(a4)


*----------------------------------------------------------------------------*
*  [NGA

		.offset 0
color_tab:	.ds.w	16*16
start_addr:	.ds.l	1
colum:		.ds.w	1
line:		.ds.w	1
gbuff:		.ds.l	1
color_table	.ds.l	1
size_of_data:
		.text

data:
		.ds.b	size_of_data

rewrite_table
		.dc.w	pat1-data,1
		.dc.w	pat2-data,0
		.dc.w	pat3-data,-1
		.dc.w	pat4-data,1
		.dc.w	pat5-data,0
		.dc.w	pat7-data,-1
		.dc.w	pat8-data,1
		.dc.w	pat9-data,0
		.dc.w	pat10-data,0
		.dc.w	pat11-data,-1
		.dc.w	pat12-data,1
		.dc.w	pat13-data,1
		.dc.w	pat14-data,0
		.dc.w	pat16-data,-1
		.dc.w	pat17-data,-1
		.dc.w	0

		.end
