.comment comments *-------------------------------------------------------------*
|										|
|	BMP(16/256:k) Graphic Loader for over1024/512			|
|										|
|					original program v1.10 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.xdef	bmp_header_read__
		.xdef	bmp_decode__

		.xref	getc
		.xref	getw
		.xref	getw_intel
		.xref	getl_intel
*		.xref	skip_mac_binary


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* BMP(16/256:k)摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256Fɂ炸CPsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
bmp_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		cmp.w	#8,_color(a5)
		beq	bmp_dec_256

		movea.l	_buff_addr(a5),a0
		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts

bmp_dec_256:
	.ifdef	PiH
		move.l	_buff_addr256(a5),a0
	.else
		move.l	_buff_addr(a5),a0
	.endif
		bsr	expand256
		movem.l	(sp)+,d3-d7/a3-a6
		rts


*----------------------------------------------------------------------------*
*
* BMPwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*
*----------------------------------------------------------------------------*

header_read:
bmp_header_read__:
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'B',d0
		bne	error_
		bsr	getc
		cmp.b	#'M',d0
		bne	error_

		move.w	#0,_bmp_compress(a5)
		moveq.l	#0,d1

		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc
*		bsr	getl_intel
		* d0.l				* t@CTCY

		bsr	getc
		bsr	getc
*		bsr	getw_intel
		* d0.w				* Reserved

		bsr	getc
		bsr	getc
*		bsr	getw_intel
		* d0.w				* Reserved

		bsr	getl_intel
		* d0.l				* OFFSET
		move.l	d0,d4

		bsr	getl_intel
		* d0.l				* wb_TCY
		move.l	d0,d3

		moveq.l	#31,d6			* T|[gĂȂ`.

		cmp.l	#40,d0
		beq	he40
		cmp.l	#12,d0
		beq	he12

		bra	error_

he40:
		bsr	getl_intel		* 
		move.w	d0,_colum(a5)

		bsr	getl_intel		* c
		move.w	d0,_line(a5)

		moveq.l	#31,d6			* T|[gĂȂ`.
		bsr	getw_intel		* v[
		cmp.w	#1,d0
		bne	error_

		moveq.l	#36,d6			* 16FȊỎ摜ɂ͑ΉĂȂ.
		bsr	getw_intel		* Phbg̃rbg
		move.w	d0,_color(a5)

		moveq.l	#31,d6			* T|[gĂȂ`
		bsr	getl_intel		* k
		move.w	d0,_bmp_compress(a5)
		tst.b	d0
		beq	@f
		move.b	#'r',_PP_flag(a5)
@@:

**		bsr	getl_intel		* k̃C[WTCY
		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

**		bsr	getl_intel		* P̉hbg
		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

**		bsr	getl_intel		* P̏chbg
		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

**		bsr	getl_intel		* rbg}bvł̎gpF
		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

**		bsr	getl_intel		* rbg}bvł̍pxgpF
		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

		bra	head_cont

he12:

		bsr	getw_intel		* 
		move.w	d0,_colum(a5)

		bsr	getw_intel		* c
		move.w	d0,_line(a5)

		moveq.l	#31,d6			* T|[gĂȂ`.
		bsr	getw_intel		* v[
		cmp.w	#1,d0
		bne	error_

		moveq.l	#36,d6			* 16FȊỎ摜ɂ͑ΉĂȂ.
		bsr	getw_intel		* Phbg̃rbg
		move.w	d0,_color(a5)

head_cont:
		move.l	#0,_scolum(a5)
*		clr.w	_scolum(a5)
*		clr.w	_sline(a5)

		cmp.w	#8,_color(a5)
		beq	head256

		move.w	_colum(a5),d0
		move.w	d0,d1
		and.w	#%111,d1
		tst.w	d1
		beq	@f
		and.w	#$fff8,d0
		addq.w	#8,d0
@@:		move.w	d0,_colum(a5)
		subq.w	#1,d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		move.w	d0,_eline(a5)
		bra	head_cont2
head256:
		move.w	_colum(a5),d0
		move.w	d0,d1
		and.w	#%11,d1
		beq	@f
		or.w	#%11,d0
		addq.w	#1,d0
@@:		move.w	d0,_colum(a5)
		subq.w	#1,d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		move.w	d0,_eline(a5)

head_cont2:
		bsr	bmp_palet

		move.w	#0,-(sp)
		move.l	d4,-(sp)
		move.w	_file(a5),-(sp)
		.dc.w	$FF42		* DOS	_SEEK
		addq.l	#8,sp

		moveq.l	#0,d0
		rts

error_:
		moveq.l	#-1,d0
		rts


*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

bmp_palet:
		tst.w	_palet(a5)
		bne	bmp_palet_end
		lea.l	_pal_buf(a5),a0
		moveq.l	#1,d2
		move.w	_color(a5),d0
		cmp.w	#8,d0
		bhi	bmp_palet_end
		lsl.w	d0,d2
		subq.w	#1,d2
		st.b	_rgb_flag(a5)
		lea.l	_rgb(a5),a2
**		moveq.l	#16-1,d2
palet_loop:
		bsr	getc		* B
		move.b	d0,2(a2)
		and.w	#$00f8,d0
		ror.w	#2,d0
		move.w	d0,d1
		bsr	getc		* G
		move.b	d0,1(a2)
		and.w	#$00f8,d0
		ror.w	#8,d0
		or.w	d0,d1
		bsr	getc		* R
		move.b	d0,(a2)
		and.w	#$00f8,d0
		rol.w	#3,d0
		or.w	d0,d1
		cmp.w	#40,d3
		bne	@f
		bsr	getc
@@:		move.w	d1,(a0)+
		addq.l	#3,a2
		dbra	d2,palet_loop
bmp_palet_end:
		rts


*----------------------------------------------------------------------------*
*
* 16/256摜WJC
*
*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
* 16FWJC
*----------------------------------------------------------------------------*

expand:
		move.w	_colum(a5),d4
		move.w	_line(a5),d2

		move.w	d4,d0
		mulu.w	d2,d0
		adda.l	d0,a0
		lea.l	(a0),a2		* zGRAM̍Ō+1܂łĂ.

		subq.w	#1,d2		* Y-loopp

		move.w	d4,d3
		neg.w	d4
		lsr.w	#3,d3
		subq.w	#1,d3		* X-loopp
		move.w	d3,d5		* X-loopޔp

outlop:
		move.w	d5,d3
		lea.l	(a2,d4.w),a2
		lea.l	(a2),a0
inlop:
		move.l	(a1)+,d0
		move.l	d0,d1
		lsr.l	#4,d1
		and.l	#%00001111_00001111_00001111_00001111,d0
		and.l	#%00001111_00001111_00001111_00001111,d1

		swap.w	d0
		swap.w	d1
		move.w	d1,-(sp)
		move.b	(sp)+,(a0)+
		move.w	d0,-(sp)
		move.b	(sp)+,(a0)+
		move.b	d1,(a0)+
		move.b	d0,(a0)+

		swap.w	d0
		swap.w	d1
		move.w	d1,-(sp)
		move.b	(sp)+,(a0)+
		move.w	d0,-(sp)
		move.b	(sp)+,(a0)+
		move.b	d1,(a0)+
		move.b	d0,(a0)+

		dbra	d3,inlop
		dbra	d2,outlop

		rts


*----------------------------------------------------------------------------*
* 256FWJC
*----------------------------------------------------------------------------*

expand256:
		move.w	_colum(a5),d4
		move.w	_line(a5),d2

		move.w	d4,d0
		mulu.w	d2,d0
		adda.l	d0,a0
		lea.l	(a0),a2		* zGRAM̍Ō+1܂łĂ.

		subq.w	#1,d2		* Y-loopp

		move.w	d4,d3
		neg.w	d4
		lsr.w	#2,d3
		subq.w	#1,d3		* X-loopp
		move.w	d3,d5		* X-loopޔp

outlop_:
		move.w	d5,d3
		lea.l	(a2,d4.w),a2
		lea.l	(a2),a0
inlop_:
		move.l	(a1)+,(a0)+

		dbra	d3,inlop_
		dbra	d2,outlop_

		rts


		.end
