.comment comments *-------------------------------------------------------------*
|										|
|	BMP(16/256:k) Graphic Saver for over1024/512			|
|										|
|					original program v1.10 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_BMPSave__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* BMP(16/256:k)摜Z[u
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256F́CPsNZPoCgD
*        zGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_BMPSave__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	BMPSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

BMPSave
		bsr	bmp_color_set		* colorF48,24 // 8  24 ̎w߂邩H
		bsr	bmp_head_write

		move.w	bmp_color(pc),d0
		cmp.w	#8,d0
		beq	BMPSave256
		cmp.w	#24,d0
		beq	BMPSave16M
BMPSave16
		move.w	_colum(a5),d0
		and.w	#%111,d0
		bne	BMPSave16_not8bit
BMPSaver16_8bit:
		bsr	press
		bra	BMPSaveLAST

BMPSave16_not8bit:
		bsr	press16_not8bit
		bra	BMPSaveLAST

BMPSave256:
		bsr	press256
		bra	BMPSaveLAST

BMPSave16M:
		bsr	press16M
*		bra	BMPSaveLAST

BMPSaveLAST
		move.l	d0,d6

		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		move.l	d6,d0
		rts


*----------------------------------------------------------------------------*
* J[Zbgi-to8, -to24pj

bmp_color_set:
		lea.l	bmp_color(pc),a0
		move.w	_color(a5),(a0)
		move.w	#0,2(a0)
		move.w	_to_color(a5),d0
		ble	@f	* bmi + beq
		move.w	_color(a5),d1
		cmp.w	#4,d1
		beq	color4_set
		cmp.w	#8,d1
		beq	color8_set
@@:		rts

color8_set:				*
		cmp.w	#24,d0
		bne	@b
		move.w	d0,(a0)
		rts
color4_set:				* 
		cmp.w	#8,d0
		bne	@f
		move.w	d0,(a0)
		move.w	#256-16-1,2(a0)
@@:		cmp.w	#24,d0
		bne	@@b
		move.w	d0,(a0)
		rts
bmp_color:
	.dc.w	0
bmp_4to8:
	.dc.w	0


*----------------------------------------------------------------------------*
*
* BMPwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Ewb_́C40bytes`łD
*
*----------------------------------------------------------------------------*

bmp_head_write:
		lea.l	_commentx(a5),a0
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_

		move.w	#'BM',(a0)+

		move.l	d0,(a0)+		* File Size ɌvZD

		clr.w	(a0)+			* Reserved
		clr.w	(a0)+			* Reserved

						* OFFSETvZ
		move.w	bmp_color(pc),d0
		move.l	#54+16*4,d1
		cmp.w	#4,d0
		beq	@f
		move.l	#54+256*4,d1
		cmp.w	#8,d0
		beq	@f
		move.l	#54,d1
@@:		ror.w	#8,d1
		swap.w	d1
		ror.w	#8,d1
		move.l	d1,(a0)+		* OFFSET

		moveq.l	#40,d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* Header size

		moveq.l	#0,d0
		move.w	_colum(a5),d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* X Size

		moveq.l	#0,d0
		move.w	_line(a5),d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* Y Size

		moveq.l	#1,d0
		ror.w	#8,d0
		move.w	d0,(a0)+		* Plane

		move.w	bmp_color(pc),d0
		ror.w	#8,d0
		move.w	d0,(a0)+		* Color.

		clr.l	(a0)+			* Compress mode.

		clr.l	(a0)+			* Compress picdata size.

		moveq.l	#1,d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* 1m X dots.

		moveq.l	#1,d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* 1m Y dots.

		moveq.l	#0,d0
		ror.w	#8,d0
		swap.w	d0
		ror.w	#8,d0
		move.l	d0,(a0)+		* BMP use colors.

		clr.l	(a0)+			* high frequency used color.

		bsr	bmp_palet_save

		bsr	bmp_filesize_save

		move.l	a0,d0
		lea.l	_commentx(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		pea.l	_commentx(a5)
		move.w	d5,-(sp)
		DOS	_WRITE			܂ł̃wb_o
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#0,d0
		rts

bmp_filesize_save:
		move.l	a0,d2
		lea.l	_commentx(a5),a1
		sub.l	a1,d2
		addq.l	#2,a1

		move.w	bmp_color(pc),d0
		cmp.w	#4,d0
		beq	color4_filesize
		cmp.w	#8,d0
		beq	color8_filesize
color16M_filesize:
		move.w	_colum(a5),d1
		mulu.w	#3,d1
		move.w	d1,d0
		and.w	#%11,d0
		beq	@f
		or.w	#%11,d1
		addq.w	#1,d1
@@:		mulu.w	_line(a5),d1
		bra	bmp_filesize_main
color4_filesize:
		move.w	_colum(a5),d1
		move.w	d1,d0
		and.w	#%111,d0
		beq	@f
		or.w	#%111,d1
		addq.w	#1,d1
@@:		mulu.w	_line(a5),d1
		lsr.l	#1,d1
		bra	bmp_filesize_main
color8_filesize:
		move.w	_colum(a5),d1
		move.w	d1,d0
		and.w	#%11,d0
		beq	@f
		or.w	#%11,d1
		addq.w	#1,d1
@@:		mulu.w	_line(a5),d1
		bra	bmp_filesize_main
bmp_filesize_main:
		add.l	d1,d2
		ror.w	#8,d2
		swap.w	d2
		ror.w	#8,d2
		move.l	d2,(a1)+		* File size
		rts


*----------------------------------------------------------------------------*
* pbgZ[u

bmp_palet_save:
		move.w	bmp_color(pc),d1
		cmp.w	#24,d1
		beq	bmp_palet_save_end
		move.w	_color(a5),d1		* ӁII
		lea.l	_pal_buf(a5),a1
		moveq.l	#1,d0
		lsl.w	d1,d0
		subq.w	#1,d0
		tst.b	_rgb_flag(a5)
		bne	true_color
pisave0
		move.w	(a1)+,d1

		move.w	d1,d2
		and.w	#$3f,d2		* B
					* %            11_1110
		rol.w	#2,d2		* 
		move.b	d2,(a0)+

		move.w	d1,d2
		and.w	#$f800,d2	* G
					* %1111_1000_0000_0000
		rol.w	#8,d2
		move.b	d2,(a0)+

		move.w	d1,d2
		and.w	#$7c0,d2	* R
					* %      111_1100_0000
		ror.w	#3,d2
		move.b	d2,(a0)+

		clr.b	(a0)+		* Reserved.

		dbra	d0,pisave0
		bsr	comp4to8
bmp_palet_save_end:
		rts

true_color:
		lea.l	_rgb(a5),a1
@@:
		move.b	2(a1),(a0)+	* B
		move.b	1(a1),(a0)+	* G
		move.b	(a1),(a0)+	* R

		clr.b	(a0)+		* Reserved.

		addq.l	#3,a1

		dbra	d0,@b
		bsr	comp4to8
		rts

comp4to8:
		move.w	bmp_4to8(pc),d0
		beq	@@f
		moveq.l	#0,d1
@@:		move.l	d1,(a0)+
		dbra	d0,@b
@@:		rts


*----------------------------------------------------------------------------*
*
* 16/256摜Z[uC
*
*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
* 4bit(16F)Z[o[ÊP
* TCY8bit̔{̏ꍇ́CZ[u[hŁD

press:
	moveq.l	#32,d0		* 0%\
	moveq.l	#32,d1
	bsr	line_disp

* -- 2pixel 1byte ɕϊ.
	movea.l	_buff_addr(a5),a0
	movea.l	a0,a1
	move.w	_colum(a5),d2
	mulu.w	_line(a5),d2
	lsr.l	#2,d2			* 4Ŋ
l_01:
	move.l	(a0)+,d0					* 12
	move.l	d0,d1						* 4
	lsr.l	#4,d1						* 16
	or.l	d1,d0						* 8
	move.l	d0,d1						* 4
	swap.w	d1						* 4
	move.b	d1,-(sp)					* 8
	move.w	(sp)+,d1					* 8
	move.b	d0,d1						* 4
	move.w	d1,(a1)+					* 8 92.

	dbra	d2,l_01
	clr.w	d2
	subq.l	#1,d2
	bcc	l_01

	moveq.l	#32,d0		* 50%\
	moveq.l	#16,d1
	bsr	line_disp

* ㌴__ϊ
	movea.l	_buff_addr(a5),a0
	move.w	_colum(a5),d2
	mulu.w	_line(a5),d2
	lsr.l	#1,d2			* 2Ŋ
	adda.l	d2,a0
	movea.l	a0,a2
	movea.l	a0,a1

	move.w	_colum(a5),d1
	move.w	d1,d3
*	lsr.w	#1,d3
	lsr.w	d3
	neg.w	d3
	lsr.w	#3,d1
	subq.w	#1,d1
reverse:
	move.w	_line(a5),d4
	subq.w	#1,d4

outlop:
	move.w	d1,d0
	lea.l	(a2,d3.w),a2
	lea.l	(a2),a0
@@:	move.l	(a0)+,(a1)+
	dbra	d0,@b
	dbra	d4,outlop

	bsr	line_disp_x

		movea.l	_buff_addr(a5),a0
		move.w	_colum(a5),d1
		mulu.w	_line(a5),d1
		lsr.l	#1,d1			* 2Ŋ
		adda.l	d1,a0

		move.l	d1,-(sp)
		move.l	a0,-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea	10(sp),sp
		tst.l	d0
		bmi	error_write
		cmp.l	d1,d0
		bne	error_diskfree
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
* 4bit(16F)Z[o[ÊQ
* TCY8bit̔{łȂꍇ́CnɍƁD

press16_not8bit:
	moveq.l	#32,d0		*  0%\
	moveq.l	#32,d1
	bsr	line_disp

	bsr	not8_mask

	move.w	_colum(a5),d0
	and.w	#%111,d0
	moveq.l	#8,d2
	sub.w	d0,d2

* -- 2pixel 1byte ɕϊ
	movea.l	_buff_addr(a5),a0
	movea.l	a0,a1
	move.w	_line(a5),d4
	subq.w	#1,d4
not8_outlop:
		move.l	a1,a2	* ޔ

		move.w	_colum(a5),d3
		or.w	#%111,d3
		addq.w	#1,d3
		lsr.w	#2,d3			* 4Ŋ
		subq.w	#1,d3
not8_inlop:
			move.b	(a0)+,d0
			move.b	d0,-(sp)
			move.w	(sp)+,d0
			move.b	(a0)+,d0
			swap.w	d0
			move.b	(a0)+,d0
			move.b	d0,-(sp)
			move.w	(sp)+,d0
			move.b	(a0)+,d0
*			move.l	(a0)+,d0					* 12
			move.l	d0,d1						* 4
			lsr.l	#4,d1						* 16
			or.l	d1,d0						* 8
			move.l	d0,d1						* 4
			swap.w	d1						* 4
			move.b	d1,-(sp)					* 8
			move.w	(sp)+,d1					* 8
			move.b	d0,d1						* 4
			move.w	d1,(a1)+					* 8 92.

		dbra	d3,not8_inlop

		and.l	d7,-4(a1)
		suba.l	d2,a0

	dbra	d4,not8_outlop

* ㌴__ϊ
	movea.l	_buff_addr(a5),a0
	move.w	_colum(a5),d2
	or.w	#%111,d2
	addq.w	#1,d2
	mulu.w	_line(a5),d2
	lsr.l	#1,d2			* 2Ŋ
	adda.l	d2,a0
	movea.l	a0,a2
**	movea.l	a0,a1

	move.w	_colum(a5),d1
	or.w	#%111,d1
	addq.w	#1,d1
	move.w	d1,d3
*	lsr.w	#1,d3
	lsr.w	d3
	neg.w	d3
	lsr.w	#3,d1
	subq.w	#1,d1
**	bra	reverse

	move.w	_line(a5),d4
	subq.w	#1,d4
outlop_:
	move.w	d1,d0
	lea.l	(a2,d3.w),a2
	lea.l	(a2),a0
@@:	move.l	(a0)+,(a1)+
	dbra	d0,@b
	dbra	d4,outlop_

	bsr	line_disp_x

		movea.l	_buff_addr(a5),a0
		move.w	_colum(a5),d1
		or.w	#%111,d1
		addq.w	#1,d1
		mulu.w	_line(a5),d1
		lsr.l	#1,d1			* 2Ŋ
		adda.l	d1,a0
		move.l	d1,-(sp)
		move.l	a0,-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea	10(sp),sp
		tst.l	d0
		bmi	error_write
		cmp.l	d1,d0
		bne	error_diskfree
		moveq.l	#0,d0
	rts

not8_mask:
	move.w	_colum(a5),d0
	and.w	#%111,d0
	add.w	d0,d0
	add.w	d0,d0
	lea.l	not8_masktable(pc,d0.w),a0
	move.l	(a0),d7
	rts

not8_masktable:
	.dc.l	0			* dummy
	.dc.l	%1111_0000_0000_0000__0000_0000_0000_0000	*1
	.dc.l	%1111_1111_0000_0000__0000_0000_0000_0000	*2
	.dc.l	%1111_1111_1111_0000__0000_0000_0000_0000	*3
	.dc.l	%1111_1111_1111_1111__0000_0000_0000_0000	*4
	.dc.l	%1111_1111_1111_1111__1111_0000_0000_0000	*5
	.dc.l	%1111_1111_1111_1111__1111_1111_0000_0000	*6
	.dc.l	%1111_1111_1111_1111__1111_1111_1111_0000	*7


*----------------------------------------------------------------------------*
* 8bit(256F)Z[o[

press256:
	move.l	_save_size(a5),d7
	move.w	_colum(a5),d6
	move.w	d6,d0
	move.w	d0,d1
	and.w	#%11,d1
	beq	@f
	or.w	#%11,d0
	addq.w	#1,d0
@@:	divu.w	d0,d7				* 
	mulu.w	d7,d0
	movea.l	d0,a2

	moveq.l	#0,d3
	tst.w	d1
	beq	@f
	moveq.l	#4,d3
	sub.w	d1,d3
@@:	subq.w	#1,d3

	move.w	_line(a5),d4
	subq.w	#1,d4
	moveq.l	#0,d2
	movea.l	_save_addr(a5),a0
outlop256:
		move.w	d6,d1
		mulu.w	d4,d1
		movea.l	_buff_addr(a5),a1
		adda.l	d1,a1

		move.w	d6,d1
		subq.w	#1,d1
@@:
			move.b	(a1)+,(a0)+
		dbra	d1,@b

		move.w	d3,d1
		bmi	@@f
@@:
			move.b	#0,(a0)+
		dbra	d1,@b
@@:

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f

		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		tst.l	d0
		bmi	error_write
		cmp.l	a2,d0
		bne	error_diskfree
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop256

	tst.w	d2
	beq	press256_end
	move.w	#0,d4			* 100%\
	bsr	ldisp

	move.l	a0,d1			* File Flush.
	sub.l	_save_addr(a5),d1
	move.l	d1,-(sp)
	move.l	_save_addr(a5),-(sp)
	move.w	d5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	tst.l	d0
	bmi	error_write
	cmp.l	d1,d0
	bne	error_diskfree
press256_end:
	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
* 24bit(1677F)Z[o[ÊP
* 1pixel 1byte p

press16M:
	move.l	_save_size(a5),d7
	move.w	_colum(a5),d6
	move.w	d6,d0
	mulu.w	#3,d0
	move.w	d0,d1
	and.w	#%11,d1
	beq	@f
	or.w	#%11,d0
	addq.w	#1,d0
@@:	divu.w	d0,d7				* 
	mulu.w	d7,d0
	movea.l	d0,a2

	moveq.l	#0,d3
	tst.w	d1
	beq	@f
	moveq.l	#4,d3
	sub.w	d1,d3
@@:	subq.w	#1,d3

	move.w	_line(a5),d4
	subq.w	#1,d4
	moveq.l	#0,d2
	movea.l	_save_addr(a5),a0

	tst.w	_rgb_flag(a5)
	bne	press16M_true_color

	lea.l	_pal_buf(a5),a4
outlop16M:
		move.w	d6,d1
		mulu.w	d4,d1
		movea.l	_buff_addr(a5),a1
		adda.l	d1,a1

		swap.w	d2
		move.w	d6,d1
		subq.w	#1,d1
@@:
			move.w	#0,d2
			move.b	(a1)+,d2
			add.w	d2,d2

			move.w	(a4,d2.w),d0
			and.w	#%0000000000111110,d0	* B
			rol.w	#2,d0
			move.b	d0,(a0)+

			move.w	(a4,d2.w),d0
			and.w	#%1111100000000000,d0	* G
			rol.w	#8,d0
			move.b	d0,(a0)+

			move.w	(a4,d2.w),d0
			and.w	#%0000011111000000,d0	* R
			ror.w	#3,d0
			move.b	d0,(a0)+

		dbra	d1,@b

		move.w	d3,d1
		bmi	@@f
@@:
			move.b	#0,(a0)+
		dbra	d1,@b
@@:
		swap.w	d2

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f

		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		tst.l	d0
		bmi	error_write
		cmp.l	a2,d0
		bne	error_diskfree
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop16M

file_flush:
	tst.w	d2
	beq	press16M_end
	move.w	#0,d4			* 100%\
	bsr	ldisp

	move.l	a0,d1			* File Flush.
	sub.l	_save_addr(a5),d1
	move.l	d1,-(sp)
	move.l	_save_addr(a5),-(sp)
	move.w	d5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	tst.l	d0
	bmi	error_write
	cmp.l	d1,d0
	bne	error_diskfree
press16M_end:
	moveq.l	#0,d0
	rts

press16M_true_color:
	lea.l	_rgb(a5),a4

outlop16M_tc_lop:
		move.w	d6,d1
		mulu.w	d4,d1
		movea.l	_buff_addr(a5),a1
		adda.l	d1,a1

		swap.w	d2
		move.w	d6,d1
		subq.w	#1,d1
@@:
			moveq.l	#0,d2
			move.b	(a1)+,d2
			move.w	d2,d0
			add.w	d2,d2
			add.w	d0,d2

			move.b	2(a4,d2.w),(a0)+	* B
			move.b	1(a4,d2.w),(a0)+	* G
			move.b	(a4,d2.w),(a0)+		* R

		dbra	d1,@b

		move.w	d3,d1
		bmi	@@f
@@:
			move.b	#0,(a0)+
		dbra	d1,@b
@@:
		swap.w	d2

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f

		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		tst.l	d0
		bmi	error_write
		cmp.l	a2,d0
		bne	error_diskfree
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop16M_tc_lop
	bra	file_flush


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	_line(a5),d0
		move.w	d4,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error_:
		move.l	d6,d0
		rts

error_write:
		moveq.l	#4,d0
		rts

error_diskfree:
		moveq.l	#7,d0
		rts

		.end
