		.title	mph3 - comment_get.s


* Include File -------------------------------- *

		.include	doscall.mac
		.include	iocscall.mac
		.include	mph.h
		.include	mph_lib.h
		.include	mph_format.h
		.include	config.h


* Global Symbol ------------------------------- *

	.xref	getc
	.xref	mph_header
	.xref	con_on
	.xref	con_off

	.xdef	comment_form
	.xdef	comment_file_get
	.xdef	comment_get
	.xdef	commentx_get
	.xdef	comment_user_get

	.comment title

	MPH3 Comment routines.

					written by Herzen

title

* KCCTITLECUSERCSAVER̂ƁD
CTITLE:		.equ	1024*0
CUSER:		.equ	1024*3
CSAVER:		.equ	1024*4


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

comment_form:
		move	(_comm,a5),d0
		bne	comment_form_chk

		cmpi	#MPH_SAVER,(_mode,a5)
		beq	comment_saver

		tst.b	(_not_comment_flag,a5)	* Rg邩HiJXCb`j
		bne	comment_form_end	* Ȃ̂łΏI

		lea	(_comment,a5),a1
comment_convert_main:
		bsr	from_comment
		bsr	to_comment
comment_form_end:
		rts

* -

to_comment:
		move.w	_dst(a5),d0
		cmp.w	#MAG,d0
		beq	toMAG
		cmp.w	#PI,d0
		beq	toPI
		cmp.w	#HG,d0
		beq	toHG
		cmp.w	#GH,d0
		beq	toGH
toDEF:
		clr.b	_comment(a5)
		rts

toMAG:
		lea	(_comment,a5),a0
		move.l	(_mph_head,a5),(a0)+
		move.b	#' ',(a0)+
		tst.b	(cu_flag,a5)
		bne	1f
		lea	(_commentx+CUSER,a5),a1
		tst.b	(a1)
		bne	@f
1:		lea	(_mph_user,a5),a1
@@:
		moveq.l	#19-1,d2
@@:		move.b	(a1)+,d0
		beq	@f
		cmp.b	#13,d0
		beq	@f
		move.b	d0,(a0)+
		dbra	d2,@b
		bra	toMAG_cont0
@@:		move.b	#' ',(a0)+
		dbra	d2,@b
toMAG_cont0:
		move.w	#CUSER-CTITLE-1,d1
		lea.l	_commentx+CTITLE(a5),a1
@@:		move.b	(a1)+,(a0)+
		dbeq	d1,@b
		rts

toPI:
toGH:
		tst.b	_commentx+CTITLE(a5)
		bne	toPI_main
		tst.b	_commentx+CUSER(a5)
		beq	toDEF
toPI_main:
		tst.b	(_commentx+CUSER,a5)
		beq	toPI_commentcpy

		lea	(_comment,a5),a0
		move.l	#'User',(a0)+
		move.b	#':',(a0)+
		tst.b	(cu_flag,a5)
		bne	1f
		lea	(_commentx+CUSER,a5),a1
		tst.b	(a1)
		bne	@f
1:		lea	(_mph_user,a5),a1
@@:		bsr	strcpy
		move.b	#13,(a0)+
		move.b	#10,(a0)+
toPI_commentcpy:
		lea.l	_commentx+CTITLE(a5),a1
		bsr	strcpy
		rts

toHG:
		tst.b	_commentx+CTITLE(a5)
		bne	toHG_main
		tst.b	_commentx+CUSER(a5)
		beq	toDEF
toHG_main:
		tst.b	_commentx+CUSER(a5)
		beq	toPI_commentcpy

		lea	(_comment,a5),a0
		move.l	#'HG: ',(a0)+
		move.l	(_mph_head,a5),(a0)+
		move.b	#' ',(a0)+
		tst.b	(cu_flag,a5)
		bne	1f
		lea	(_commentx+CUSER,a5),a1
		tst.b	(a1)
		bne	@f
1:		lea	(_mph_user,a5),a1
@@:		bsr	strcpy
		move.b	#13,(a0)+
		move.b	#10,(a0)+
		lea.l	_commentx+CTITLE(a5),a1
		bsr	strcpy
		rts


* -

from_comment:
		move.w	_src(a5),d0
		cmp.w	#MAG,d0
		beq	fromMAG
		cmp.w	#PI,d0
		beq	fromPI
		cmp.w	#HG,d0
		beq	fromHG
		cmp.w	#GH,d0
		beq	fromPI
		cmp.w	#Q4,d0
		beq	fromQ4

fromDEF:
		tst.b	_QQflag(a5)		* .Q4DRg擾邩H
		beq	fromDEF_main
		bsr	comment_q4d_get
		bra	fromQ4_main
fromDEF_main:
		clr.b	_commentx+CSAVER(a5)
		clr.b	_commentx+CUSER(a5)
		clr.b	_commentx+CTITLE(a5)
		rts

fromMAG:
		tst.b	_QQflag(a5)		* .Q4DRg擾邩H
		beq	fromMAG_main
		bsr	comment_q4d_get
		bmi	fromMAG_main
		bra	fromQ4_main
fromMAG_main:
		lea.l	_commentx+CSAVER(a5),a0	* @햼
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+
		move.b	(a1)+,(a0)+

		addq.l	#1,a1			* [U[
		lea.l	_commentx+CUSER-1(a5),a0
		move.b	#' ',(a0)+		* ׂăXy[XꍇɑΏ
		tst.b	(a1)
		beq	fromMAG_err1
@@:
		moveq.l	#19-1,d2
@@:		move.b	(a1)+,d0
		beq	fromMAG_err1
		move.b	d0,(a0)+
		dbra	d2,@b
@@:
		cmp.b	#' ',-(a0)
		beq	@b
		addq.l	#1,a0
		clr.b	(a0)
		move.w	#CUSER-CTITLE-1,d1
		lea.l	_commentx+CTITLE(a5),a0
@@:		move.b	(a1)+,(a0)+
		dbeq	d1,@b
		rts
fromMAG_err1:
		clr.b	(a0)
fromMAG_err2:
		clr.b	_commentx+CTITLE(a5)
		rts

fromPI:
fromGH:
		clr.b	_commentx+CSAVER(a5)	* @햼
		tst.b	_QQflag(a5)		* .Q4DRg擾邩H
		beq	@f
		bsr	comment_q4d_get
		bmi	@f
		bra	fromQ4_main
@@:		tst.b	_6USER(a5)		* UڂUserĂ̂`FbN邩H
		bne	fromPI_6USER
		tst.b	_fromMAGflag(a5)	* 'MAKI02  'wb_,MAGwb_Ƃ邩H
		bne	fromPI_MAKI
fromPI_main:	lea.l	_commentx+CUSER(a5),a0
		movea.l	a1,a2
		cmp.l	#'User',(a2)+
		bne	fromPI_nouser
		cmp.b	#':',(a2)+
		bne	fromPI_nouser
		move.w	#CSAVER-CUSER-1,d1
@@:		move.b	(a2)+,d0
		beq	fromMAG_err1
		cmp.b	#13,d0
		beq	@f
		cmp.b	#10,d0
		beq	@f
		move.b	d0,(a0)+
		dbra	d1,@b
		bsr	LINESKIPa2
		bra	fromPI_cont0
@@:		cmp.b	#13,d0
		bne	fromPI_cont0
		addq.l	#1,a2
fromPI_cont0:
		movea.l	a2,a1
fromPI_nouser:
		clr.b	(a0)
		move.w	#CUSER-CTITLE-1,d1
		lea.l	_commentx+CTITLE(a5),a0
@@:		move.b	(a1)+,(a0)+
		dbeq	d1,@b
		rts

fromPI_6USER:
		lea.l	_commentx+CUSER(a5),a0
		movea.l	a1,a2
		moveq.l	#6-1,d0
@@:		tst.b	(a1)+
		beq	fromPI_cont0
		dbra	d0,@b
**		movea.l	a1,a2
		movea.l	a2,a1
		cmp.l	#'User',(a2)+
		bne	@f
		cmp.b	#':',(a2)+
		beq	fromPI_main		* 'User:'̂Ȃ狭IfromPI_main
@@:
		movea.l	a1,a2
		cmp.l	#'MAKI',(a2)+		* 'MAKI02  'Ȃ6USERƂfromMAG_main
		bne	fromMAG_main
		cmp.l	#'02  ',(a2)+
		bne	fromMAG_main
		tst.b	_fromMAGflag(a5)	* 'MAKI02  'wb_,MAGwb_Ƃ邩H
		beq	fromPI_main		* Ⴄ̂Ȃ6USERłȂCfromPI_main
		movea.l	a2,a1
		bra	fromMAG_main
fromPI_MAKI:
		movea.l	a1,a2
		cmp.l	#'MAKI',(a2)+
		bne	fromPI_main
		cmp.l	#'02  ',(a2)+
		bne	fromPI_main
		movea.l	a2,a1
		bra	fromMAG

fromHG:
		clr.b	_commentx+CSAVER(a5)	* @햼
		tst.b	_QQflag(a5)		* .Q4DRg擾邩H
		beq	@f
		bsr	comment_q4d_get
		bmi	@f
		bra	fromQ4_main
@@:		tst.b	_6USER(a5)		* UڂUserĂ̂`FbN邩H
		bne	fromHG_6USER
		tst.b	_fromMAGflag(a5)	* 'MAKI02  'wb_,MAGwb_Ƃ邩H
		bne	fromHG_MAKI
fromHG_main:
		lea.l	_commentx+CUSER(a5),a0
		movea.l	a1,a2
		cmp.l	#'User',(a2)+
		bne	@f
		cmp.b	#':',(a2)+
		beq	fromPI_main		* User: ̂Ȃ fromPI_main 
@@:
		movea.l	a1,a2
		cmp.l	#'HG: ',(a2)+
		bne	fromHG_nouser

		moveq.l	#5-1,d0
@@:		tst.b	(a2)+			* Z[o@͔΂.
		beq	fromMAG_err1
		dbra	d0,@b

		move.w	#CSAVER-CUSER-1,d1
@@:		move.b	(a2)+,d0
		beq	fromMAG_err1
		cmp.b	#13,d0
		beq	@f
		cmp.b	#10,d0
		beq	@f
		move.b	d0,(a0)+
		dbra	d1,@b
		bsr	LINESKIPa2
		bra	fromHG_cont0
@@:		cmp.b	#13,d0
		bne	fromHG_cont0
		addq.l	#1,a2
fromHG_cont0:
		movea.l	a2,a1
fromHG_nouser:
		clr.b	(a0)
		move.w	#CUSER-CTITLE-1,d1
		lea.l	_commentx+CTITLE(a5),a0
@@:		move.b	(a1)+,(a0)+
		dbeq	d1,@b
		rts

fromHG_6USER:
		lea.l	_commentx+CUSER(a5),a0
		movea.l	a1,a2
		moveq.l	#6-1,d0
@@:		tst.b	(a1)+
		beq	fromHG_cont0
		dbra	d0,@b
**		movea.l	a1,a2
		movea.l	a2,a1
		cmp.l	#'User',(a2)+
		bne	@f
		cmp.b	#':',(a2)+
		beq	fromPI_main		* 'User:'̂Ȃ狭IfromPI_main
@@:
		movea.l	a1,a2
		cmp.l	#'HG: ',(a2)+
		beq	fromHG_main		* 'HG: '̂Ȃ狭IfromHG_main

		movea.l	a1,a2
		cmp.l	#'MAKI',(a2)+		* 'MAKI02  'Ȃ6USERƂfromMAG_main
		bne	fromMAG_main
		cmp.l	#'02  ',(a2)+
		bne	fromMAG_main
		tst.b	_fromMAGflag(a5)	* 'MAKI02  'wb_,MAGwb_Ƃ邩H
		beq	fromHG_main		* Ⴄ̂Ȃ6USERłȂCfromPI_main
		movea.l	a2,a1
		bra	fromMAG_main
fromHG_MAKI:
		movea.l	a1,a2
		cmp.l	#'MAKI',(a2)+
		bne	fromHG_main
		cmp.l	#'02  ',(a2)+
		bne	fromHG_main
		movea.l	a2,a1
		bra	fromMAG


fromQ4:
		tst.b	_Qflag(a5)
		beq	fromDEF
		bsr	comment_q4d_get
		bmi	fromDEF
fromQ4_main:
		bsr	comment_q4d_trans
		rts

* -


comment_form_chk:
		cmp.w	#1,d0
		bne	comment_form_chk_cut
		tst.b	_from_cg_flag(a5)
		bne	comment_from_cg
comment_form_chk_file:					* -cfŃRgt@Cw莞̏
		lea	(_comment_from_file,a5),a1
		lea	(_comment,a5),a0
		bsr	strcpy
		cmpi	#MAG,(_dst,a5)
		bne	comment_form_chk_file_end

		lea	(_comment,a5),a0
		move.l	(_mph_head,a5),(a0)+
		move.b	#' ',(a0)+
comment_form_chk_file_end:
		rts

comment_from_cg:					* -cg̎̓ʏ
		lea.l	_comment_from_file(a5),a1
		cmp.w	#'Pi',(a1)
		beq	cf_pi
		cmp.w	#'GH',(a1)
		beq	cf_pi
		cmp.w	#'HG',(a1)
		beq	cf_hg
		cmp.l	#'MAKI',(a1)
		bne	comment_form_chk_file
		cmp.l	#'02  ',4(a1)
		bne	comment_form_chk_file
cf_mag:
		addq.l	#8,a1		* 'MAKI02  '̕΂.
		move.w	_src(a5),-(sp)
		move.w	#MAG,_src(a5)
		bsr	comment_convert_main
		move.w	(sp)+,_src(a5)
		rts
cf_pi:
		addq.l	#2,a1		* 'Pi'̕΂.
		move.w	_src(a5),-(sp)
		move.w	#PI,_src(a5)
		bsr	comment_convert_main
		move.w	(sp)+,_src(a5)
		rts
cf_hg:
		move.w	_src(a5),-(sp)
		move.w	#HG,_src(a5)
		move.l	a1,-(sp)
		lea.l	7(a1),a0		* 'HG2.0',13,10̕΂.
		exg.l	a0,a1
		bsr	strcpy
		move.l	(sp)+,a1
		bsr	comment_convert_main
		move.w	(sp)+,_src(a5)
		rts

comment_form_chk_cut:				* -ccŃRgJbgw莞̏
		lea	(_comment,a5),a0
		clr.b	(a0)
		cmpi	#MAG,(_dst,a5)
		bne	comment_form_chk_end

		move.l	(_mph_head,a5),(a0)+	* MAG....
		move.b	#' ',(a0)+
		lea	(_mph_user,a5),a1
		bsr	strcpy
comment_form_chk_end:
		rts

*-------------------------------------------
**
** _commentx+CTITLE = TITLE
** _commentx+CUSER = AUTHOR
**

comment_q4d_trans:
		movem.l	a0-a2,-(sp)
		lea.l	_commentx+CTITLE(a5),a0
		lea.l	_tmp(a5),a1
		bra	@f
loop:
		bsr	LINESKIP
@@:		tst.b	(a1)
		beq	@f
		lea.l	q4d_title(pc),a2
		bsr	strcmp
		bne	loop
		addq.l	#2,a1			* ' :' '@'Ƃ΂.
		bsr	strcpy_to_return
@@:
		clr.b	(a0)

		lea.l	_commentx+CUSER(a5),a0
		lea.l	_tmp(a5),a1
		lea.l	q4d_author_1(pc),a2
		move.l	a2,d2
		lea.l	q4d_author_2(pc),a2
		move.l	a2,d3
		lea.l	q4d_author_3(pc),a2
		move.l	a2,d4

		bra	@f
loop2:
		bsr	LINESKIP
@@:		tst.b	(a1)
		beq	q4d_comment_end

		move.l	d2,a2
		move.l	a1,d1
		bsr	strcmp
		beq	q4d_author_ok
		move.l	d1,a1

		move.l	d3,a2
		move.l	d1,a1
		bsr	strcmp
		beq	q4d_author_ok
		move.l	d1,a1

		move.l	d4,a2
		bsr	strcmp
		beq	q4d_author_ok

		bra	loop2

q4d_author_ok:
		addq.l	#2,a1
		bsr	strcpy_to_return
q4d_comment_end:
		clr.b	(a0)
		movem.l	(sp)+,a0-a2
		rts


q4d_title:
	.dc.b	'y^Cgz',0
q4d_author_1:
	.dc.b	'y@@ҁz',0
q4d_author_2:
	.dc.b	'yҖz',0
q4d_author_3:
	.dc.b	'y    ҁz',0

LINESKIP:
		cmp.b	#10,(a1)+
		bne	LINESKIP
		rts
LINESKIPa2:
		cmp.b	#10,(a2)+
		bne	LINESKIPa2
		rts

strcmp:
	tst.b	(a2)
	beq	strcmp_ok
	cmp.b	(a1)+,(a2)+
	beq	strcmp
	moveq.l	#-1,d0
	tst.l	d0
	rts

strcmp_ok:
	moveq.l	#0,d0
	tst.l	d0
	rts


*------ comment q4d file read routine.

comment_q4d_get:

		bsr	con_on
		moveq.l	#2,d6
		move.w	#0,-(sp)
		pea.l	_srcfile_q4d(a5)
		DOS	_OPEN
		addq.l	#6,sp
		bsr	con_off
		move.w	d0,d2
		bmi	error

		lea.l	_tmp(a5),a1
		move.l	#1024,d1
		move.l	d1,-(sp)
		move.l	a1,-(sp)
		move.w	d2,-(sp)
		DOS	_READ
		lea	10(sp),sp
		tst.l	d0
		bmi	error_
		lea.l	(a1,d1.l),a1
		clr.b	(a1)
		move.b	#13,(a1)+
		move.b	#10,(a1)+
		moveq.l	#20,d0
@@:		move.b	#' ',(a1)+
		dbra	d0,@b
		move.b	#13,(a1)+
		move.b	#10,(a1)+
		clr.b	(a1)

		move.w	d2,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		moveq.l	#0,d0
		rts

error_:
		move.w	d2,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		moveq.l	#-1,d0
		rts


*
*------ comment file read routine.

comment_file_get:
		bsr	con_on
		moveq.l	#2,d6
		move.w	#0,-(sp)
		move.l	a0,-(sp)
		DOS	_OPEN
		addq.l	#6,sp
		bsr	con_off
		move.w	d0,d2
		bmi	error

		move.w	#2,-(sp)
		pea.l	0.w
		move.w	d2,-(sp)
		DOS	_SEEK
		move.l	d0,d1
		move.w	#0,6(sp)
		DOS	_SEEK
		addq.l	#8,sp

		cmp.l	#1024-64,d1
		bcs	@f
		move.l	#1024-64,d1
@@:
		lea.l	_comment_from_file(a5),a0
		moveq.l	#3,d6
		move.l	d1,-(sp)
		move.l	a0,-(sp)
		move.w	d2,-(sp)
		DOS	_READ
		lea	10(sp),sp
		tst.l	d0
		bmi	error_
		clr.b	(a0,d1.l)

		move.w	d2,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		lea.l	_comment_from_file(a5),a0
@@:		move.b	(a0)+,d0
		beq	@f
		cmp.b	#$1a,d0
		bne	@b
		clr.b	-(a0)
@@:
error:
		rts


*
*
*------ Pi/MAG/HG/GH comment get routine.

comment_get:
		move.w	_comm(a5),d0
		beq	com_get
*		cmp.w	#1,d0
*		beq	com_lop
com_lop:
		bsr	getc
		cmp.b	#26,d0
		bne	com_lop
		rts
com_get:
		lea.l	_comment(a5),a0
commentx
		bsr	getc
		cmp.b	#26,d0
		beq	com0
		move.b	d0,(a0)+
		bra	commentx
com0		
		clr.b	(a0)+
**		move.b	#$1a,(a0)
		rts


commentx_get:
		lea.l	_commentx(a5),a0
commentx_lop:
		bsr	getc
		cmp.b	#26,d0
		beq	comx0
		move.b	d0,(a0)+
		bra	commentx_lop
comx0:
		clr.b	(a0)+
		tst.w	_comm(a5)
		bne	comx_get_end
		lea.l	_commentx(a5),a1
		lea.l	_comment(a5),a0
		bsr	strcpy
comx_get_end:
		rts


*
*
*
comment_saver:
		bsr	fromDEF_main
		tst.b	(cu_flag,a5)
		beq	1f

		lea	(_mph_user,a5),a0	;-cuw莞͎w肵[Ugp
		lea	(_commentx+CUSER,a5),a1
@@:		move.b	(a0)+,(a1)+
		bne	@b
		bra	to_comment
1:
		clr.b	(_commentx+CUSER,a5)
		tst.b	(_save_not_user_flag,a5)
		bne	to_comment		;-suw莞

		pea	(_commentx+CUSER,a5)
		clr.l	-(sp)
		pea	(usr_string,pc)
		DOS	_GETENV
		lea	(12,sp),sp
		bra	to_comment

usr_string:
	.dc.b	'USER',0
	.even

*
*
comment_user_get:
		lea.l	_commentx(a5),a0
		lea.l	_comment(a5),a1
		bsr	strcpy

		bsr	none

		lea.l	_commentx(a5),a1
		lea.l	_comment(a5),a0
		move.w	_src(a5),d0
		cmp.w	#MAG,d0
		beq	usr_mag
		cmp.w	#PI,d0
		beq	usr_pi
		cmp.w	#HG,d0
		beq	usr_hg
		cmp.w	#GH,d0
		beq	usr_gh

none:
		lea.l	_comment(a5),a0
		move.l	#'None',(a0)+
		move.l	#'    ',(a0)+
		move.l	#'    ',(a0)+
		move.l	#'    ',(a0)+
		move.l	#'   '.shl.8,(a0)+

		rts
usr_mag:
		addq.l	#5,a1
usr_main:
		moveq.l	#19-1,d1
@@:		move.b	(a1)+,d0
		beq	usr_mag_end
		cmp.b	#13,d0
		beq	usr_mag_end
		move.b	d0,(a0)+
		dbra	d1,@b
usr_mag_end:
*		clr.b	(a0)
		lea.l	_comment(a5),a0
		cmp.l	#'><',(a0)+
		beq	none
		tst.b	_comment(a5)
		beq	none
		rts

usr_pi:
usr_hg:
usr_gh:
		tst.b	_fromMAGflag(a5)
		beq	usr_pi_
		cmp.l	#'MAKI',(a1)+
		bne	usr_pi_
		cmp.l	#'02  ',(a1)+
		beq	usr_mag
usr_pi_:
		lea.l	_commentx(a5),a1
		cmp.l	#'User',(a1)+
		bne	usr_hg_
		cmp.b	#':',(a1)+
		bne	usr_hg_
		bra	usr_main

usr_hg_:
		lea.l	_commentx(a5),a1
		cmp.l	#'HG: ',(a1)+
		bne	none
		addq.l	#5,a1
		bra	usr_main

	.end
