		.title	mph3 - format_dep.s


	.include	doscall.mac
	.include	iocscall.mac
	.include	mph.h
	.include	mph_format.h
	.include	config.h
	.include	mph_lib.h
	.include	gif_save.h

	.xref	con_on
	.xref	con_off

	.xdef	dst_chk
	.xdef	depend_chk
	.xdef	format_chk
	.xdef	malloc
	.xdef	malloc_free
	.xdef	gram_malloc
	.xdef	gram_malloc_free
	.xdef	ext_table_set
	.xdef	ext_string

	.if	0
		.xdef	malloc_disp
	.endif

	.comment title

	MPH2 depend on format routines.

					written by Herzen

title


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

ext_table_set:
		pea	(ext_table,pc)
		move.l	(sp)+,(_ext_table_addr,a5)
		rts

format:		.macro	extname
		.dc.b	'.&extname'
		.even
		.endm

* (loader/saver)
ext_table:
		.include	mph_format.h

*		.dc.l	'.MAG'
*		.dc.l	'.PI'<<8
*		.dc.l	'.HG'<<8
*		.....


ext_string:
		move.l		a1,-(sp)
		add.w		d0,d0
		add.w		d0,d0
		lea.l		(ext_table,pc,d0.w),a1
		tst.b		3(a1)
		bne		@f
		move.b		#' ',(a0)+
@@:		tst.b		2(a1)
		bne		@f
		move.b		#' ',(a0)+
@@:		move.b		1(a1),(a0)+
		tst.b		2(a1)
		beq		ext_string_end
		move.b		2(a1),(a0)+
		tst.b		3(a1)
		beq		ext_string_end
		move.b		3(a1),(a0)+
ext_string_end:
		move.l		(sp)+,a1
		rts

*
*
*  ˑ`FbNi[_[`Ă邩ۂj
*  iloaderj
*

depend_chk:
		movem.l	d1/d2,-(sp)
		moveq	#1,d0			;
		move	(_src,a5),d1
		move.l	#1<<MAG+1<<PI+1<<HG+1<<GH+1<<BMP+1<<GIF+1<<PIX+1<<PT4,d2
		btst	d1,d2
		bne	@f
		moveq	#2,d0			;O
@@:		movem.l	(sp)+,d1/d2
		rts

*
*
*  o̓tH[}bg`FbN
*  isaverj
*

* in	d0.l	gq('.MAG','.PI'<<8)
* out	d1.l	0: -1:ΉtH[}bg

dst_chk:
		move.l	a0,-(sp)
		lea	(dst_chk_table,pc),a0
@@:
		move	(a0)+,d1
		bmi	dst_chk_error
		cmp.l	(a0)+,d0
		bne	@b

		move	d1,(_dst,a5)
		moveq	#0,d1
		movea.l	(sp)+,a0
		rts
dst_chk_error:
		moveq	#-1,d1
		movea.l	(sp)+,a0
		rts

dst_chk_table:
		.dc	MAG
		.dc.l	'.MAG'

		.dc	PI
		.dc.l	'.PI'<<8

		.dc	HG
		.dc.l	'.HG'<<8

		.dc	GH
		.dc.l	'.GH'<<8

		.dc	BMP
		.dc.l	'.BMP'

		.dc	Q0
		.dc.l	'.Q0'<<8

		.dc	RGB
		.dc.l	'.RGB'

		.dc	GIF
		.dc.l	'.GIF'

		.dc	PIX
		.dc.l	'.PIX'

		.dc	GLM
		.dc.l	'.GLM'

		.dc	GLX
		.dc.l	'.GLX'

		.dc	-1			;end of table


*
*
*  tH[}bg`FbN
*  (loader)
*

* srcfile_get ̒Ɏs.

format_chk:
	clr.b	_mac_binary(a5)
	moveq.l	#0,d6
	bsr	con_on
	clr.w	-(sp)
	pea.l	_srcfile(a5)
	DOS	_OPEN
	addq.l	#6,sp
	bsr	con_off
	cmp.l	#-68,d0
	beq	CHK_END
	moveq.l	#1,d6
	move.l	d0,d1
	bmi	CHK_END
	lea.l	_commentx(a5),a1
	lea.l	(a1),a2
	move.l	#1024,-(sp)
	move.l	a1,-(sp)
	move.w	d1,-(sp)
	DOS	_READ
	move.l	d0,d2
	DOS	_CLOSE
	lea	(10,sp),sp

CHK_MAG:
	cmp.l	#100,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.l	#'MAKI',(a1)+
	bne	@f
	cmp.l	#'02  ',(a1)+
	bne	@f
	move.w	#MAG,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_PI:
	cmp.l	#72,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.w	#'Pi',(a1)+
	bne	@f
	move.w	#PI,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_HG:
	cmp.l	#50,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.w	#'HG',(a1)+
	bne	@f
	move.w	#HG,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_GIF:
	cmp.l	#30,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.l	#'GIF8',(a1)+
	bne	@f
	move.w	#GIF,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_MKI:
	cmp.l	#50,d2			* ͓K(^^;
	bcs	@f
	lea.l	(a2),a1
	cmp.l	#'MAKI',(a1)+
	bne	@f
	cmp.w	#'01',(a1)+
	bne	@f
	cmp.b	#'A',(a1)
	beq	1f
	cmp.b	#'B',(a1)
	bne	@f
1:	addq.l	#1,a1
	move.b	(a1)+,_mki_com(a5)
	move.b	(a1)+,_mki_com+1(a5)
	move.b	(a1)+,_mki_com+2(a5)
	move.b	(a1)+,_mki_com+3(a5)
	tst.b	39(a2)
	sne.b	_200flag(a5)
	move.w	#MKI,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_Q4:
	cmp.l	#$10,d2
	bcs	@f
	lea.l	(a2),a1
	tst.b	1(a1)
	bne	@f
	cmp.b	#1,3(a1)
	bhi	@f
	lea.l	11(a1),a1
	cmp.b	#'M',(a1)+
	bne	@f
	cmp.b	#'A',(a1)+
	bne	@f
	cmp.b	#'J',(a1)+
	bne	@f
	cmp.b	#'Y',(a1)+
	bne	@f
	cmp.b	#'O',(a1)+
	bne	@f
	move.w	#Q4,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_GRA:
	cmp.l	#$10,d2
	bcs	@f
	lea.l	(a2),a1
	tst.b	6(a1)
	bne	@f
	lea.l	$d(a1),a1
	cmp.b	#'W',(a1)+
	bne	@f
	cmp.b	#'E',(a1)+
	bne	@f
	cmp.b	#'D',(a1)+
	bne	@f
	move.w	#GRA,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_QPC:
	cmp.l	#$10,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.l	#'QPC ',(a1)+
	bne	@f
	cmp.l	#'Grap',(a1)+
	bne	@f
	cmp.l	#'hic ',(a1)+
	bne	@f
	cmp.l	#'Data',(a1)+
	bne	@f
	cmp.l	#' Hea',(a1)+
	bne	@f
	cmp.l	#'dder',(a1)+
	bne	@f
	cmp.l	#' Blo',(a1)+
	bne	@f
	cmp.w	#'ck',(a1)+
	bne	@f
	move.w	#QPC,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_GH:
	cmp.l	#78,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.w	#'GH',(a1)+
	bne	@f
	move.w	#GH,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_PIC:
	cmp.l	#100,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.w	#'PI',(a1)+
	bne	@f
	cmp.b	#'C',(a1)+
	bne	@f
1:	tst.b	(a1)+
	bne	1b
	addq.l	#2,a1
	move.b	(a1)+,d0
	lsl.w	#8,d0
	move.b	(a1)+,d0
	moveq.l	#36,d6			* 16ȊO͑ΉĂȂ.
	cmp.w	#4,d0			* PIC16
	bne	CHK_END
	move.w	#PIC,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_BMP:
	cmp.l	#20,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.w	#'BM',(a1)+
	bne	@f
	move.w	#BMP,_src(a5)
	moveq.l	#0,d0
	rts

@@:
CHK_PIX:
	cmp.l	#48,d2
	bcs	@f
	lea.l	(a2),a1
	cmp.l	#'TX16',(a1)+
	bne	@f
	addq.l	#4,a1
	tst.l	(a1)+
	bne	@f
	move.w	#PIX,_src(a5)
	moveq.l	#0,d0
	rts
@@:
CHK_PT4:
	cmp.l	#8,d2
	bcs	@f
	lea.l	(a2),a1
	tst.l	(a1)+
	bne	@f
	lea.l	_nameck_ext2(a5),a1
	move.b	(a1)+,d0
	lsl.w	#8,d0
	move.b	(a1)+,d0
	swap.w	d0
	move.b	(a1)+,d0
	lsl.w	#8,d0
	move.b	(a1)+,d0
	or.l	#$00202000,d0
	cmp.l	#'.pt4',d0
	beq	1f
	or.b	#$20,d0
	cmp.l	#'.sxi',d0
	bne	@f
1:	move.w	#PT4,_src(a5)
	moveq.l	#0,d0
	rts

* l`boCi[tǂ̃`FbN
@@:
CHK_MAC:
CHK_MAC_MAG:
	cmp.l	#100+$80,d2
	bcs	CHK_MAC_PI
	lea.l	$80(a2),a1
	cmp.l	#'MAKI',(a1)+
	bne	CHK_MAC_PI
	cmp.l	#'02  ',(a1)+
	bne	CHK_MAC_PI
	move.w	#MAG,_src(a5)
	st.b	_mac_binary(a5)
	moveq.l	#0,d0
	rts
CHK_MAC_PI:
	cmp.l	#72+$80,d2
	bcs	CHK_MAC_HG
	lea.l	$80(a2),a1
	cmp.w	#'Pi',(a1)+
	bne	CHK_MAC_HG
	move.w	#PI,_src(a5)
	st.b	_mac_binary(a5)
	moveq.l	#0,d0
	rts
CHK_MAC_HG:
	cmp.l	#50+$80,d2
	bcs	CHK_MAC_GIF
	lea.l	$80(a2),a1
	cmp.w	#'HG',(a1)+
	bne	CHK_MAC_GIF
	move.w	#HG,_src(a5)
	st.b	_mac_binary(a5)
	moveq.l	#0,d0
	rts
CHK_MAC_GIF:
	cmp.l	#30+$80,d2
	bcs	CHK_OUT
**	bcs	CHK_MAC_BMP
	lea.l	$80(a2),a1
	cmp.l	#'GIF8',(a1)+
	bne	CHK_OUT
**	bne	CHK_MAC_BMP
	move.w	#GIF,_src(a5)
	st.b	_mac_binary(a5)
	moveq.l	#0,d0
	rts
CHK_MAC_BMP:
	cmp.l	#20+$80,d2
	bcs	CHK_OUT
	lea.l	$80(a2),a1
	cmp.w	#'BM',(a1)+
	bne	CHK_OUT
	move.w	#BMP,_src(a5)
	st.b	_mac_binary(a5)
	moveq.l	#0,d0
	rts


CHK_OUT:
	moveq.l	#9,d6			* łȂtH[}bg
CHK_END:
	moveq.l	#-1,d0
	rts


*
*
*  m
*

malloc_alls:	.macro
		.local		malloc_end

		move.l		#$fffc00,d1		* d1.l = malloc size
		move.l		d1,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bpl		malloc_end

		move.l		d0,d1
		and.l		#$ffff00,d1
		sub.l		#1024,d1
		bmi		malloc_end		* can't alloc
		move.l		d1,-(sp)
		DOS		_MALLOC
		addq.l		#4,sp
malloc_end:
		.endm

*-------------------------------------------------------------------------------
*  WJp
*  (loader/saver)
*  ... ʂɃ[NKvƂꍇȊÓCȂĂ悢D

malloc_free:
		moveq.l		#0,d0
		moveq.l		#0,d7
		cmp.w		#1,_malloc(a5)
		bne		malloc_free_end

		addq.l		#1,d7
		move.l		_linewk_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		malloc_free_end
		clr.l		_linewk_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_slidewk_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		malloc_free_end
		clr.l		_slidewk_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_buff_addr(a5),d1
		beq		@f
		sub.l		#FOR_PI,d1
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		malloc_free_end
		clr.l		_buff_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_gif_savework_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		malloc_free_end
		clr.l		_gif_savework_addr(a5)
@@:
		moveq.l		#0,d0
		clr.w		_malloc(a5)
malloc_free_end:
		rts

malloc:
		tst.w		_malloc(a5)
		bne		malloc_end

		moveq.l		#6,d6
		move.l		#HG_LINEWK,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_linewk_addr(a5)

		cmp.w	#HG,_dst(a5)
		bne	@f

		move.l		#HG_SLIDEWK,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_slidewk_addr(a5)
@@:

		cmp.w	#GIF,_dst(a5)
		bne	@f
		move.l		#workend_gif-work_gif,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_gif_savework_addr(a5)
@@:

		malloc_alls				* Z[u(GRAMf[^WJ)m
		tst.l		d0
		bmi		error_malloc
		add.l		#FOR_PI,d0
		move.l		d0,_buff_addr(a5)
		sub.l		#FOR_PI,d1
		bmi		error_malloc
		move.l		d1,_buff_size(a5)
		moveq.l		#0,d0
		move.w		#1,_malloc(a5)

malloc_end:
		rts

*-------------------------------------------------------------------------------
*  OvZXp
*  (loader/saver)

gram_malloc_free:
		moveq.l		#0,d0
		moveq.l		#0,d7
		cmp.w		#2,_malloc(a5)
		bne		gram_malloc_free_end

@@:
		addq.l		#1,d7
		move.l		_linewk_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_linewk_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_save_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_save_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_save_addr2(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_save_addr2(a5)
@@:
		addq.l		#1,d7
		move.l		_slidewk_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_slidewk_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_gif_savework_addr(a5),d1
		beq		@f
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_gif_savework_addr(a5)
@@:
		addq.l		#1,d7
		move.l		_buff_addr(a5),d1
		beq		@f
		sub.l		#FOR_PI,d1
		move.l		d1,-(sp)
		DOS		_MFREE
		move.l		d0,(sp)+
		bmi		gram_malloc_free_end
		clr.l		_buff_addr(a5)
@@:
		moveq.l		#0,d0
		clr.w		_malloc(a5)
gram_malloc_free_end:
		rts

gram_malloc:
		tst.w		_malloc(a5)
		bne		gram_malloc_end

		moveq.l		#6,d6
		move.l		#HG_LINEWK,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_linewk_addr(a5)

		bsr		malloc_all
		tst.l		d0
		bmi		gram_malloc_end

		malloc_alls
		tst.l		d0
		bmi		error_malloc
		add.l		#FOR_PI,d0
		move.l		d0,_buff_addr(a5)
		sub.l		#FOR_PI,d1
		bmi		error_malloc
		move.l		d1,_buff_size(a5)
		moveq.l		#0,d0
		move.w		#2,_malloc(a5)
gram_malloc_end:
		rts


malloc_all:
		move.w		_dst(a5),d0
		cmp.w		#HG,d0
		beq		malloc_hg
		cmp.w		#PI,d0
		beq		malloc_pi
		cmp.w		#BMP,d0
		beq		malloc_pi
		cmp.w		#GIF,d0
		beq		malloc_gif
malloc_mag:						* ftHg
		move.l		#768*1024,d1
		move.l		d1,-(sp)		* TCY
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		moveq.l		#0,d0
		rts
malloc_pi:
		move.l		#128*1024+1024+2*FOR_PI256,d1
		move.l		d1,-(sp)		* TCY
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		moveq.l		#0,d0
		rts
malloc_hg:
		move.l		#HG_SLIDEWK,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_slidewk_addr(a5)
		move.l		#378*1024,d1
		move.l		d1,-(sp)		* TCY
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		move.l		#1024/8*1024,-(sp)	; half-byte buffer size ( MAX )
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_save_addr2(a5)
		moveq.l		#0,d0
		rts
malloc_gif:
		move.l		#512*1024,d1
		move.l		d1,-(sp)		* TCY
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_save_addr(a5)
		move.l		d1,_save_size(a5)
		move.l		#workend_gif-work_gif,-(sp)
		DOS		_MALLOC
		move.l		d0,(sp)+
		bmi		error_malloc
		move.l		d0,_gif_savework_addr(a5)
		moveq.l		#0,d0
		rts


error_malloc:
		moveq.l	#-1,d0
		rts


	.if	0
malloc_disp:
		bsr		con_on
		move.l		_buff_addr(a5),d0
		bsr		HEXOUT
		move.l		_save_addr(a5),d0
		bsr		HEXOUT
		move.l		_save_addr2(a5),d0
		bsr		HEXOUT
		move.l		_linewk_addr(a5),d0
		bsr		HEXOUT
		move.l		_slidewk_addr(a5),d0
		bsr		HEXOUT
		bsr		con_off
		rts
	.endif


		.end
