.comment comments *-------------------------------------------------------------*
|										|
|	GH Graphic Loader							|
|										|
|					original program v1.01 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.xdef	gh_header_read__
		.xdef	gh_decode__

		.xref	getc
		.xref	getw
		.xref	comment_get


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* GH摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 2/16/256F́CPsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
gh_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	_buff_addr(a5),a0
		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts


*----------------------------------------------------------------------------*
*
* GHwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*
*----------------------------------------------------------------------------*

header_read:
gh_header_read__
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'G',d0
		bne	error_
		bsr	getc
		cmp.b	#'H',d0
		bne	error_
		moveq.l	#0,d1

		bsr	comment_get

@@:		bsr	getc
		tst.b	d0
		bne	@b

		bsr	getc
		bsr	getc
		bsr	getc
		bsr	getc

		bsr	getw
		move.w	d0,_scolum(a5)
		bsr	getw
		move.w	d0,_sline(a5)
		bsr	getw
		move.w	d0,_colum(a5)
		bsr	getw
		move.w	d0,_line(a5)
		bsr	getw
		move.w	d0,_color(a5)

@@:		bsr	getc
		cmp.b	#'p',d0
		bne	@b
		bsr	getc	* a
		bsr	getc	* l
		bsr	getc	* e
		bsr	getc	* t
		bsr	getc	* :

		bsr	gh_palet

		bsr	getc	* 13
		bsr	getc	* 10
		bsr	getc	* d
		bsr	getc	* a
		bsr	getc	* t
		bsr	getc	* a
		bsr	getc	* :

		move.w	_colum(a5),d0
		subq.w	#1,d0
		add.w	_scolum(a5),d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		add.w	_sline(a5),d0
		move.w	d0,_eline(a5)

		moveq.l	#0,d0
		rts

error_:
		moveq.l	#-1,d0
		rts


*----------------------------------------------------------------------------*
*  pbg擾
*----------------------------------------------------------------------------*

gh_palet:
		moveq.l	#1,d2
		move.w	_color(a5),d0
		cmp.w	#8,d0
		bhi	gh_palet_end
		lsl.w	d0,d2
		subq.w	#1,d2

		lea	_pal_buf(a5),a4
		moveq.l	#1,d1
		lsl.w	d0,d1
		subq.w	#1,d1
pal_lop:	bsr	getw
		tst.w	_palet(a5)
		bne	@f
		move.w	d0,(a4)+
@@:		dbra	d1,pal_lop
gh_palet_end:
		rts


*----------------------------------------------------------------------------*
*
* 摜WJC
*
*----------------------------------------------------------------------------*

expand:
		move.w	_colum(a5),d2
		mulu.w	_line(a5),d2

		move.w	_color(a5),d0
		cmp.w	#15,d0
		bcs	data_load_main

		move.l	d2,d1
		add.l	d2,d2

		cmp.w	#24,d0
		bne	data_load_main
		add.l	d1,d2
data_load_main:

		subq.l	#1,d2
lop:
		move.b	(a1)+,(a0)+
		dbra	d2,lop
		clr.w	d2
		subq.l	#1,d2
		bcc	lop

		rts

		.end
