.comment comments *-------------------------------------------------------------*
|										|
|	GLM/GLX Graphic Saver for over1024/512					|
|										|
|					original program v1.00 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_GLMSave__
		.xdef	_GLXSave__

* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* GLM/GLX摜Z[u
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256F́CPsNZPoCgD
*        zGRAMpłCGRAMZ[u͂ȂD
*
*----------------------------------------------------------------------------*

_GLMSave__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	GLMSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

_GLXSave__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	GLXSave
		movem.l	(sp)+,d3-d7/a3-a6
		rts

GLXSave
		bsr	glx_head_write
		tst.w	d0
		bne	@f
		bra	Save_main

GLMSave
		bsr	glm_head_write
		tst.w	d0
		bne	@f

Save_main
		bsr	data_save
		tst.w	d0
		bne	@f

		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		moveq.l	#0,d0
@@:
		rts


*----------------------------------------------------------------------------*
*
* GLM/GLXwb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) ƂɂȂ
*
*----------------------------------------------------------------------------*

glx_head_write:
		lea.l	_commentx(a5),a0
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_
		move.w	_colum(a5),d0
		ror.w	#8,d0
		move.w	d0,(a0)+
		move.w	_line(a5),d0
		ror.w	#8,d0
		move.w	d0,(a0)+
		bra	head_write_main

glm_head_write:
		lea.l	_commentx(a5),a0
		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_

		move.l	#'GR65',(a0)+
		move.w	_colum(a5),d0
		mulu.w	_line(a5),d0
		add.l	d0,d0
		addq.l	#8,d0
		move.l	d0,(a0)+
		move.l	#0,(a0)+
		move.w	_colum(a5),(a0)+
		move.w	_line(a5),(a0)+

head_write_main:
		move.l	a0,d1
		lea.l	_commentx(a5),a0
		sub.l	a0,d1
		move.l	d1,-(sp)
		pea.l	_commentx(a5)
		move.w	d5,-(sp)
		DOS	_WRITE			܂ł̃wb_o
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#7,d6
		cmp.l	d0,d1
		bne	file_error_
		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* 摜f[^oC
*
*----------------------------------------------------------------------------*

data_save:
	move.l	_save_size(a5),d7
	move.w	_colum(a5),d0
	add.w	d0,d0
	divu.w	d0,d7				* 
	mulu.w	d7,d0
	movea.l	d0,a2

	movea.l	_buff_addr(a5),a1

	move.w	_line(a5),d4
	subq.w	#1,d4
	moveq.l	#0,d2

	lea.l	_pal_buf(a5),a4

	movea.l	_save_addr(a5),a0
outlop:
		move.w	_colum(a5),d1
		subq.w	#1,d1
		moveq.l	#0,d0
@@:
			move.w	d0,d3
			move.b	(a1)+,d3
			add.w	d3,d3
			move.w	(a4,d3.w),(a0)+

		dbra	d1,@b

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f
		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_
		moveq.l	#7,d6
		cmp.l	a2,d0
		bne	file_error_
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop

file_flush:
	tst.w	d2
	beq	@f
	move.w	#0,d4			* 100%\
	bsr	ldisp
	move.w	_colum(a5),d1		* FILE FLUSH!!
	add.w	d1,d1
	mulu.w	d2,d1
	move.l	d1,-(sp)
	move.l	_save_addr(a5),-(sp)
	move.w	d5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_error_
	moveq.l	#7,d6
	cmp.l	d1,d0
	bne	file_error_
@@:
	moveq.l	#0,d0
	rts


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	_line(a5),d0
		move.w	d4,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error_:
		move.l	d6,d0
		rts

		.end
