.comment comments *-------------------------------------------------------------*
|										|
|	PIX/PT4 Graphic Loader							|
|										|
|					original program v1.01 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

	.ifdef	PiH
* PiH SYS p
		.include	pih.h
		.include	lib.h
		.xdef		header_read
		.xdef		decode
	.else
* MPH p
		.include	mph.h
		.include	mph_lib.h
	.endif
* ȉCʒ`

		.xdef	pix_header_read__
		.xdef	pt4_header_read__
		.xdef	pix_decode__
		.xdef	pt4_decode__

		.xref	getc
		.xref	getw
		.xref	getw_intel
		.xref	getl_intel


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* PIX/PT4摜WJ
*
* in  a1.l = ꂩWJׂ摜f[^ۑĂꏊDREADDATA
*            ( DOS _READ œǂݍ񂾃f[^̐擪AhX )
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) PsNZPoCgœWJD
*        zGRAMpłCGRAMWJ͂ȂD
*
*----------------------------------------------------------------------------*

decode:
pix_decode__:
pt4_decode__:
		movem.l	d3-d7/a3-a6,-(sp)
		movea.l	_buff_addr(a5),a0	* a0 = zGRAM
		bsr	expand
		movem.l	(sp)+,d3-d7/a3-a6
		rts


*----------------------------------------------------------------------------*
*
* PT4wb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*
*----------------------------------------------------------------------------*

pt4_header_read__
		moveq.l	#30,d6
		bsr	getc	* KO
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_

		bsr	getw			* 
		move.w	d0,_colum(a5)

		bsr	getw			* c
		move.w	d0,_line(a5)

		move.w	#4,_color(a5)

		move.l	#0,_scolum(a5)

		move.w	_colum(a5),d0
		subq.w	#1,d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		move.w	d0,_eline(a5)

		bsr	pt4_palet

		moveq.l	#0,d0
		rts

pt4_palet:
		tst.w	_palet(a5)
		bne	pt4_palet_end

		lea.l	_pal_buf(a5),a0
		lea.l	SXPALET(pc),a1
		moveq.l	#16-1,d0
@@:		move.w	(a1)+,(a0)+
		dbra	d0,@b
pt4_palet_end
		rts

SXPALET:
	.dc.w	$0000,$c5f1,$83e1,$0001
	.dc.w	$ffc1,$07c1,$f801,$003f
	.dc.w	$ff7f,$c5f1,$83e1,$0001
	.dc.w	$ffc1,$07c1,$f801,$003f


*----------------------------------------------------------------------------*
*
* PIXwb_ǂݍ
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[id6.w = G[R[hj
*
* (l) EDOS _OPEN ŁCt@Cnh _file(a5) Ɋi[ĂƁD
*
*----------------------------------------------------------------------------*

header_read:
pix_header_read__
		moveq.l	#30,d6
		bsr	getc
		cmp.b	#'T',d0
		bne	error_
		bsr	getc
		cmp.b	#'X',d0
		bne	error_
		bsr	getc
		cmp.b	#'1',d0
		bne	error_
		bsr	getc
		cmp.b	#'6',d0
		bne	error_

		bsr	getc	* t@CTCY|W
		bsr	getc
		bsr	getc
		bsr	getc

		bsr	getc	* KO
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_
		bsr	getc
		tst.b	d0
		bne	error_

		bsr	getw			* 
		move.w	d0,_colum(a5)

		bsr	getw			* c
		move.w	d0,_line(a5)

		move.w	#4,_color(a5)

		move.l	#0,_scolum(a5)

		move.w	_colum(a5),d0
		subq.w	#1,d0
		move.w	d0,_ecolum(a5)
		move.w	_line(a5),d0
		subq.w	#1,d0
		move.w	d0,_eline(a5)

		bsr	pix_palet

		moveq.l	#0,d0
		rts

error_:
		moveq.l	#-1,d0
		rts

pix_palet:
		lea.l	_pal_buf(a5),a0
		moveq.l	#16-1,d2
palet_loop:
		bsr	getw
		tst.w	_palet(a5)
		bne	@f
		move.w	d0,(a0)+
@@:		dbra	d2,palet_loop
pix_palet_end:
		rts


*----------------------------------------------------------------------------*
*
* 摜WJC
*
*----------------------------------------------------------------------------*

expand:
	movea.l	a0,a4

	move.w	_colum(a5),d7
	move.w	d7,d6
	lsr.w	#4,d7
	and.w	#%1111,d6
	beq	@f
	addq.w	#1,d7
@@:
	add.w	d7,d7
	move.w	d7,d0
	mulu.w	_line(a5),d0
	movea.l	a1,a0
	lea.l	(a0,d0.l),a1
	lea.l	(a1,d0.l),a2
	lea.l	(a2,d0.l),a3
	move.w	_colum(a5),d7
	lsr.w	#4,d7
	subq.w	#1,d7
	move.w	d7,a6
	subq.w	#1,d6

*----------------------------------------------------------------------------*
* ϊ

	move.w	_line(a5),d7
	subq.w	#1,d7
outlop:
		move.w	a6,d5
inlop:
		move.w	(a0)+,d0
		move.w	(a1)+,d1
		move.w	(a2)+,d2
		move.w	(a3)+,d3

		.rept 16
		moveq.l	#0,d4
		add.w	d3,d3
		addx.b	d4,d4
		add.w	d2,d2
		addx.b	d4,d4
		add.w	d1,d1
		addx.b	d4,d4
		add.w	d0,d0
		addx.b	d4,d4
		move.b	d4,(a4)+
		.endm

		dbra	d5,inlop

		move.w	d6,d5
		bmi	inlop_end

		move.w	(a0)+,d0
		move.w	(a1)+,d1
		move.w	(a2)+,d2
		move.w	(a3)+,d3

@@:		moveq.l	#0,d4
		add.w	d3,d3
		addx.b	d4,d4
		add.w	d2,d2
		addx.b	d4,d4
		add.w	d1,d1
		addx.b	d4,d4
		add.w	d0,d0
		addx.b	d4,d4
		move.b	d4,(a4)+
		dbra	d5,@b

inlop_end:
		dbra	d7,outlop

		rts

		.end
