.comment comments *-------------------------------------------------------------*
|										|
|	Q0 Graphic Saver for over1024/512					|
|										|
|					original program v1.01 by Herzen	|
|										|
comments *----------------------------------------------------------------------*

		.include	doscall.mac
		.include	mph.h
		.include	mph_lib.h

		.xdef	_Q0Save__


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

*----------------------------------------------------------------------------*
*
* Q0摜Z[u
*
* in  Ȃ
*
* out d0.w =        0 : I
*            ȊO : G[R[h
*
* (l) 16/256F́CPsNZPoCgD
*        zGRAMpłCGRAMk͂ȂD
*
*----------------------------------------------------------------------------*

_Q0Save__
		movem.l	d3-d7/a3-a6,-(sp)
		bsr	Q0Save
		movem.l	(sp)+,d3-d7/a3-a6
		rts

Q0Save
		bsr	q0_head_write
		tst.w	d0
		bne	@f

		bsr	data_save
		tst.w	d0
		bne	@f

		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
		moveq.l	#0,d0
@@:
		rts


*----------------------------------------------------------------------------*
*
* Q0wb_o
*
* in  Ȃ
*
* out d0.w =        0 : 
*            ȊO : G[R[h
*     d5.w = t@Cnh
*
* (l) Ewb_.IPR`łD
*
*----------------------------------------------------------------------------*

q0_head_write:
		move.w	#$20,-(sp)
		pea.l	_dstfile_ipr(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_

		lea.l	_tmp(a5),a0
		move.w	_colum(a5),d0
		moveq.l	#5,d1
		moveq.l	#0,d2
		bsr	LTOS
		move.w	_line(a5),d0
		moveq.l	#5,d1
		moveq.l	#0,d2
		bsr	LTOS
		move.w	#0,d0
		moveq.l	#4,d1
		moveq.l	#0,d2
		bsr	LTOS
		move.w	#0,d0
		moveq.l	#4,d1
		moveq.l	#0,d2
		bsr	LTOS

		move.l	a0,d0
		lea.l	_tmp(a5),a0
		sub.l	a0,d0
		move.l	d0,-(sp)
		pea.l	_tmp(a5)
		move.w	d5,-(sp)
		DOS	_WRITE		wb_o
		lea	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_del

		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp

		move.w	#$20,-(sp)
		pea.l	_dstfile(a5)
		DOS	_CREATE
		addq.l	#6,sp
		moveq.l	#2,d6
		move.w	d0,d5
		bmi	file_error_del2

		moveq.l	#0,d0
		rts


*----------------------------------------------------------------------------*
*
* 摜f[^oC
*
*----------------------------------------------------------------------------*

data_save:
	move.l	_save_size(a5),d7
	move.w	_colum(a5),d0
	mulu.w	#3,d0
	divu.w	d0,d7				* 
	mulu.w	d7,d0
	movea.l	d0,a2

	movea.l	_buff_addr(a5),a1

	move.w	_line(a5),d4
	subq.w	#1,d4
	moveq.l	#0,d2

	tst.w	_rgb_flag(a5)
	bne	true_color

	lea.l	_pal_buf(a5),a4

	movea.l	_save_addr(a5),a0
outlop:
		move.w	_colum(a5),d1
		subq.w	#1,d1
@@:
			moveq.l	#0,d3
			move.b	(a1)+,d3
			add.w	d3,d3

			move.w	(a4,d3.w),d0
			and.w	#%0000011111000000,d0	* R
			ror.w	#3,d0
			move.b	d0,(a0)+

			move.w	(a4,d3.w),d0
			and.w	#%1111100000000000,d0	* G
			rol.w	#8,d0
			move.b	d0,(a0)+

			move.w	(a4,d3.w),d0
			and.w	#%0000000000111110,d0	* B
			rol.w	#2,d0
			move.b	d0,(a0)+

		dbra	d1,@b

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f
		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_del
		moveq.l	#7,d6
		cmp.l	a2,d0
		bne	file_error_del
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop

file_flush:
	tst.w	d2
	beq	@f
	move.w	#0,d4			* 100%\
	bsr	ldisp
	move.w	_colum(a5),d1		* FILE FLUSH!!
	mulu.w	#3,d1
	mulu.w	d2,d1
	move.l	d1,-(sp)
	move.l	_save_addr(a5),-(sp)
	move.w	d5,-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp
	moveq.l	#4,d6
	tst.l	d0
	bmi	file_error_del
	moveq.l	#7,d6
	cmp.l	d1,d0
	bne	file_error_del
@@:
	moveq.l	#0,d0
	rts

*----------------------------------------------------------------------------*
* 24bitpbgpC

true_color:
	lea.l	_rgb(a5),a4

	movea.l	_save_addr(a5),a0
outlop__:
		move.w	_colum(a5),d1
		subq.w	#1,d1
@@:
			moveq.l	#0,d3
			move.b	(a1)+,d3
			move.w	d3,d0
			add.w	d3,d3
			add.w	d0,d3

			move.b	(a4,d3.w),(a0)+		* R
			addq.w	#1,d3
			move.b	(a4,d3.w),(a0)+		* G
			addq.w	#1,d3
			move.b	(a4,d3.w),(a0)+		* B

		dbra	d1,@b

		addq.w	#1,d2
		cmp.w	d2,d7
		bne	@f
		move.l	a2,-(sp)
		move.l	_save_addr(a5),-(sp)
		move.w	d5,-(sp)
		DOS	_WRITE
		lea.l	10(sp),sp
		moveq.l	#4,d6
		tst.l	d0
		bmi	file_error_del
		moveq.l	#7,d6
		cmp.l	a2,d0
		bne	file_error_del
		moveq.l	#0,d2
		movea.l	_save_addr(a5),a0
@@:
		bsr	ldisp
	dbra	d4,outlop__

	bra	file_flush


*----------------------------------------------------------------------------*
* Z[uoߕ
*----------------------------------------------------------------------------*

ldisp:
		movem.l	d0-d1,-(sp)
		move.w	_line(a5),d0
		move.w	d4,d1
		bsr	line_disp
		movem.l	(sp)+,d0-d1
		rts


*----------------------------------------------------------------------------*
* G[
*----------------------------------------------------------------------------*

file_error_del:
		move.w	d5,-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
file_error_del2:
		pea.l	_dstfile_ipr(a5)
		DOS	_DELETE
		addq.l	#4,sp
file_error_:
		move.l	d6,d0
		rts

		.end
